unit Find;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.StdCtrls, Vcl.ExtCtrls,
  HtSearch, HtSearch2, IniFiles, ClipBrd, MyUtility;

const
  FORM_LEFT_SHIFT   = 9;
  FORM_TOP_SHIFT    = 9;
  FORM_WIDTH_SET    = 540;
  FORM_HEIGHT_SET   = 240;
  FORM_MAX          = 'MAX';
  FORM_MIN          = 'MIN';
  FORM_NORMAL       = 'NORMAL';

type
  TFormFind = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    GroupBox1: TGroupBox;
    chkMatchCase: TCheckBox;
    chkWholeWord: TCheckBox;
    chkRegExp: TCheckBox;
    chkIncludeCRLF: TCheckBox;
    ButtonPrev: TButton;
    ButtonCancel: TButton;
    ButtonNext: TButton;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuClose: TMenuItem;
    MenuSearch: TMenuItem;
    MenuSearchNext: TMenuItem;
    MenuSearchPrev: TMenuItem;
    MenuPaste: TMenuItem;
    Edit1: TEdit;
    MenuCopy: TMenuItem;
    MenuCut: TMenuItem;
    MainMenu2: TMainMenu;
    MenuFile2: TMenuItem;
    MenuClose2: TMenuItem;
    MenuSearch2: TMenuItem;
    MenuSearchNext2: TMenuItem;
    MenuSearchPrev2: TMenuItem;
    MenuCopy2: TMenuItem;
    MenuCut2: TMenuItem;
    MenuPaste2: TMenuItem;
    CheckBox1: TCheckBox;
    Timer2: TTimer;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormActivate(Sender: TObject);

    procedure ReadIniFileValue(Sender: TObject);
    procedure WriteIniFileValue(Sender: TObject);

    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonPrevClick(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);

    procedure MenuCloseClick(Sender: TObject);
    procedure MenuSearchNextClick(Sender: TObject);
    procedure MenuSearchPrevClick(Sender: TObject);
    procedure MenuPasteClick(Sender: TObject);
    procedure MenuCopyClick(Sender: TObject);
    procedure MenuCutClick(Sender: TObject);
    procedure MenuSearchNext2Click(Sender: TObject);
    procedure MenuSearchPrev2Click(Sender: TObject);

    procedure chkRegExpClick(Sender: TObject);

    procedure SetShortCutKey(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure SetShortCutNewFind(Number: String; MenuItemName: TMenuItem; Sender: TObject);

    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBox1Enter(Sender: TObject);
    procedure ComboBox1Exit(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);

    procedure Timer2Timer(Sender: TObject);

  private
    { Private 錾 }
    StrFormState: String;
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    StrSearchValue: String;
    IntSearchNext: Integer;
    StrListKeyMap: TStringList;
    StrParentForm: String;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;
  public
    { Public 錾 }
  end;

var
  FormFind: TFormFind;

implementation

uses
  Main, FindAll;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFind.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFind.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;

  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFind.FormActivate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  StrParentForm := IniFile.ReadString('FormFind', 'Parent', PARENT_MAIN);
  //j
  IniFile.Free;

  if StrParentForm = PARENT_MAIN then
  begin
    FormMain.Menu := FormMain.MainMenu2;
  end;
  if StrParentForm = PARENT_FIND_ALL then
  begin
    ;
  end;
  if StrParentForm = PARENT_FIND_FILE_ALL then
  begin
    ;
  end;
end;

procedure TFormFind.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFind', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFind', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFind', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFind', 'Left',   FormFind.Left);
    IniFile.WriteInteger('FormFind', 'Top',    FormFind.Top);
    IniFile.WriteInteger('FormFind', 'Width',  FormFind.Width);
    IniFile.WriteInteger('FormFind', 'Height', FormFind.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool   ('Options',     'MatchCase',      ChkMatchCase.Checked);
  IniFile.WriteBool   ('Options',     'AutoClose',      CheckBox1.Checked);
  //j
  IniFile.Free;

  //ݒ
  if StrParentForm = PARENT_MAIN then
  begin
    //tH[JX߂
    FormMain.SetFocus;
  end;
  if StrParentForm = PARENT_FIND_ALL then
  begin
    //tH[JX߂
    FormFindAll.SetFocus;
  end;
  if StrParentForm = PARENT_FIND_FILE_ALL then
  begin
    //tH[JX߂
    FormFindAll.SetFocus;
  end;
end;

procedure TFormFind.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormFind.FormCreate(Sender: TObject);
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //m
  StrListKeyMap := TStringList.Create;

  //ݒ
  Edit1.Visible := FALSE;

  //
  Timer2.Enabled := FALSE;

  //Create  Show ̗Őݒ肷
  //ݒ
  SetShortCutKey(Sender);
end;

procedure TFormFind.FormDestroy(Sender: TObject);
begin
  //j
  StrListKeyMap.Free;
end;

procedure TFormFind.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormKeyDowñCxgݒ肷
  FormFind.KeyPreview := TRUE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  FormPosLeft   := IniFile.ReadInteger('FormFind', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFind', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFind', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFind', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFind', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFind.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFind.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFind.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFind.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //
  IntFormShiftX   := 0;
  IntFormShiftY   := 0;

  //
  chkWholeWord.Visible := FALSE;
  chkIncludeCRLF.Visible := FALSE;
  chkRegExp.Visible := FALSE;

  //Ǎ
  ReadIniFileValue(FormFind);

//  //̓NAĂ
//  //m
//  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
//  //
//  IniFile.WriteString('Options', 'SearchWord', '');
//  //j
//  IniFile.Free;

  //tH[JXݒ
  ComboBox1.SetFocus;

  //Create  Show ̗Őݒ肷
  //ݒ
  SetShortCutKey(Sender);

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  StrParentForm := IniFile.ReadString('FormFind', 'Parent', PARENT_MAIN);
  if StrParentForm = PARENT_MAIN then
  begin
    GroupBox1.Visible := TRUE;
    CheckBox1.Visible := TRUE;
    ButtonPrev.Enabled     := TRUE;
    MenuSearchPrev.Enabled := TRUE;
  end;
  if StrParentForm = PARENT_FIND_ALL then
  begin
    GroupBox1.Visible := TRUE;
    CheckBox1.Visible := FALSE;
    ButtonPrev.Enabled     := FALSE;
    MenuSearchPrev.Enabled := FALSE;
  end;
  if StrParentForm = PARENT_FIND_FILE_ALL then
  begin
    GroupBox1.Visible := TRUE;
    CheckBox1.Visible := FALSE;
    ButtonPrev.Enabled     := FALSE;
    MenuSearchPrev.Enabled := FALSE;
  end;
  if StrParentForm = PARENT_TEXTEX then
  begin
    GroupBox1.Visible := TRUE;
    CheckBox1.Visible := TRUE;
    ButtonPrev.Enabled     := TRUE;
    MenuSearchPrev.Enabled := TRUE;
  end;
  //j
  IniFile.Free;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Find.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFind, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFind, StrLanguageFileName, Sender);
  end;

end;

procedure TFormFind.FormResize(Sender: TObject);
begin
  ComboBox1.Width := Panel1.ClientWidth - 30;
end;

procedure TFormFind.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //ENTER
  else if (Shift = []) and (key = VK_RETURN) then
  begin
    //
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFind.ComboBox1Enter(Sender: TObject);
begin
  FormFind.Menu := FormFind.MainMenu2;
end;

procedure TFormFind.ComboBox1Exit(Sender: TObject);
begin
  FormFind.Menu := MainMenu1;
end;

procedure TFormFind.ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //
  end
  //ENTER
  else if (Shift = []) and (key = VK_RETURN) then
  begin
    if ComboBox1.Text = '' then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ꂪݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Search word is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else
    begin
      ButtonNext.SetFocus;
      ButtonNextClick(Sender);
    end;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFind.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormFind.ReadIniFileValue(Sender: TObject);
var
  IniFile: TIniFile;
  StrList1: TStringList;
begin

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  ChkMatchCase.Checked      := IniFile.ReadBool   ('Options',     'MatchCase',      False);
  ChkWholeWord.Checked      := IniFile.ReadBool   ('Options',     'WholeWord',      False);
  ChkRegExp.Checked         := IniFile.ReadBool   ('Options',     'RegExp',         False);
  ChkIncludeCRLF.Checked    := IniFile.ReadBool   ('Options',     'IncludeCRLF',    False);
  IntSearchNext             := IniFile.ReadInteger('Options',     'Direction',      SEARCH_NEXT);
  ComboBox1.Text            := IniFile.ReadString ('Options',     'SearchWord',     '');
  CheckBox1.Checked         := IniFile.ReadBool   ('Options',     'AutoClose',      False);
  //j
  IniFile.Free;

  //m
  StrList1 := TStringList.Create;
  //Ǎ
  if FileExists(ExtractFilePath(ParamStr(0)) + FIND_LIST) = TRUE then
  begin
    StrList1.LoadFromFile(ExtractFilePath(ParamStr(0)) + FIND_LIST, TEncoding.Unicode);
  end
  else
  begin
    StrList1.Clear;
  end;
  //f
  ComboBox1.Items.Assign(StrList1);
  //j
  StrList1.Free;
end;

procedure TFormFind.WriteIniFileValue(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
  iMax1: Integer;
  StrList1: TStringList;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool   ('Options',     'MatchCase',      ChkMatchCase.Checked);
  IniFile.WriteBool   ('Options',     'WholeWord',      ChkWholeWord.Checked);
  IniFile.WriteBool   ('Options',     'RegExp',         chkRegExp.Checked);
  IniFile.WriteBool   ('Options',     'IncludeCRLF',    ChkIncludeCRLF.Checked);
  IniFile.WriteInteger('Options',     'Direction',      IntSearchNext);
  IniFile.WriteString ('Options',     'SearchWord',     StrSearchValue);
  IniFile.WriteBool   ('Options',     'AutoClose',      CheckBox1.Checked);
  //j
  IniFile.Free;

  //m
  StrList1 := TStringList.Create;
  //ő͈
  iMax1 := ComboBox1.Items.Count;
  if iMax1 > SERACH_MAX then
  begin
    iMax1 := SERACH_MAX;
  end;
  //ۑ
  StrList1.Clear;
  for iRow1 := 0 to iMax1-1 do
  begin
    StrList1.Add(ComboBox1.Items.Strings[iRow1]);
  end;
  //ۑ
  StrList1.SaveToFile(ExtractFilePath(ParamStr(0)) + FIND_LIST, TEncoding.Unicode);
  //j
  StrList1.Free;
end;

procedure TFormFind.chkRegExpClick(Sender: TObject);
begin
  //XE10 ł͉̂tH[\ƂɎsĂ܂̂Ŗɂ
  //ʏł͉BĂ̂ŖȂ

//  if chkRegExp.Checked = TRUE then
//  begin
//    chkMatchCase.Enabled      := FALSE;
//    chkWholeWord.Enabled      := FALSE;
//    chkIncludeCRLF.Enabled    := FALSE;
//  end
//  else
//  begin
//    chkMatchCase.Enabled      := TRUE;
//    chkWholeWord.Enabled      := TRUE;
//    chkIncludeCRLF.Enabled    := TRUE;
//  end;
end;

procedure TFormFind.ButtonNextClick(Sender: TObject);
var
  iRow1: Integer;
  sStr2: String;
  IniFile: TIniFile;
begin
  //XV
  if ComboBox1.Text <> '' then
  begin
    //ݒ
    StrSearchValue            := ComboBox1.Text;
    FormMain.StrSearchValue   := ComboBox1.Text;
    //d폜
    for iRow1 := 0 to ComboBox1.Items.Count-1 do
    begin
      if ComboBox1.Items[iRow1] = ComboBox1.Text then
      begin
        //폜
        ComboBox1.Items.Delete(iRow1);
        Break;
      end;
    end;
    //擪ɑ}
    ComboBox1.Items.Insert(0, StrSearchValue);
    if ComboBox1.Items.Count > SERACH_MAX then
    begin
      ComboBox1.Items.Delete(ComboBox1.Items.Count-1);
    end;
    //ݒ
    ComboBox1.Text := StrSearchValue;

    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //
    IniFile.WriteString ('Options', 'SearchWord', ComboBox1.Text);
    IniFile.WriteInteger('Options', 'Direction',  SEARCH_NEXT);
    //j
    IniFile.Free;
    //ݒ
    FormMain.StrSearchValue   := ComboBox1.Text;
    //ݒ
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ꂪݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Search word is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  IntSearchNext := SEARCH_NEXT;
  //
  WriteIniFileValue(Sender);
  //IvVݒ肷
  FormMain.SearchOptions   := FormMain.SetOptions  ('', SEARCH_NEXT);

  //
  if StrParentForm = PARENT_MAIN then
  begin
    if FormMain.MenuShowFileName.Checked = TRUE then
    begin
      FormMain.StatusBar1.Panels.Items[0].Text := ExtractFileName(FormMain.StrLoadFileName);
      FormMain.StatusBar2.Panels.Items[0].Text := ExtractFileName(FormMain.StrLoadFileName);
    end
    else
    begin
      FormMain.StatusBar1.Panels.Items[0].Text := StrSearchValue;
      FormMain.StatusBar2.Panels.Items[0].Text := StrSearchValue;
    end;

    // ƑO͈قȂ
    FormMain.Info.Start := FormMain.Memo1.SelStart + FormMain.Memo1.SelLength + 1;
    if HtSearch.SearchText2(PWideChar(FormMain.Memo1.Lines.Text), FormMain.Info, StrSearchValue, FormMain.SearchOptions, FormMain.Memo1) = FALSE then
    begin
      sStr2 := StringReplace(StrSearchValue, '&', '&&', [rfReplaceAll]);
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ܂܂ł' + #13#10 +
                            sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Search word can not find.' + #13#10 +
                           '[OK]' + #13#10 +
                            sStr2;
      end;
      ShowMessage(FormMain.StrMsg);
      SetForeGroundWindow(FormFind.Handle);
    end
    else
    begin
      FormMain.Memo1.SelStart  := FormMain.Info.Start;
      FormMain.Memo1.SelLength := FormMain.Info.Length;
      FormMain.Memo1.Perform(EM_SCROLLCARET, 0, 0);
      FormMain.MemoStatus(Sender);
      FormMain.SetFocus;
      if (FormMain.MenuCrLf.Checked = TRUE) or (FormMain.MenuEof.Checked  = TRUE) or
         (FormMain.MenuTab.Checked  = TRUE) or (FormMain.MenuDBCS.Checked = TRUE) then
      begin
        FormMain.Memo1.Invalidate;
      end;
      if CheckBox1.Checked = TRUE then
      begin
        ButtonCancelClick(Sender);
      end
      else
      begin
        Timer2.Enabled := TRUE;
      end;
    end;
  end;

  if StrParentForm = PARENT_FIND_ALL then
  begin
    //I
    ModalResult := mrOK;
  end;

  if StrParentForm = PARENT_FIND_FILE_ALL then
  begin
    //I
    ModalResult := mrOK;
  end;


end;

procedure TFormFind.ButtonPrevClick(Sender: TObject);
var
  iRow1: Integer;
  sStr2: String;
  IniFile: TIniFile;
begin
  //XV
  if ComboBox1.Text <> '' then
  begin
    //ݒ
    StrSearchValue            := ComboBox1.Text;
    FormMain.StrSearchValue   := ComboBox1.Text;
    //d폜
    for iRow1 := 0 to ComboBox1.Items.Count-1 do
    begin
      if ComboBox1.Items[iRow1] = ComboBox1.Text then
      begin
        //폜
        ComboBox1.Items.Delete(iRow1);
        Break;
      end;
    end;
    //擪ɑ}
    ComboBox1.Items.Insert(0, StrSearchValue);
    if ComboBox1.Items.Count > SERACH_MAX then
    begin
      ComboBox1.Items.Delete(ComboBox1.Items.Count-1);
    end;
    //ݒ
    ComboBox1.Text := StrSearchValue;

    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //
    IniFile.WriteString('Options',  'SearchWord', ComboBox1.Text);
    IniFile.WriteInteger('Options', 'Direction',  SEARCH_PREV);
    //j
    IniFile.Free;
    //ݒ
    FormMain.StrSearchValue   := ComboBox1.Text;
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ꂪݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Search word is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //
  IntSearchNext := SEARCH_PREV;
  //
  WriteIniFileValue(Sender);
  //IvVݒ肷
  FormMain.SearchOptions   := FormMain.SetOptions  ('', SEARCH_PREV);

  //
  if StrParentForm = PARENT_MAIN then
  begin
    if FormMain.MenuShowFileName.Checked = TRUE then
    begin
      FormMain.StatusBar1.Panels.Items[0].Text := ExtractFileName(FormMain.StrLoadFileName);
      FormMain.StatusBar2.Panels.Items[0].Text := ExtractFileName(FormMain.StrLoadFileName);
    end
    else
    begin
      FormMain.StatusBar1.Panels.Items[0].Text := StrSearchValue;
      FormMain.StatusBar2.Panels.Items[0].Text := StrSearchValue;
    end;

    //
    FormMain.Info.Start := FormMain.Memo1.SelStart;
    if HtSearch.SearchText1(PWideChar(FormMain.Memo1.Lines.Text), FormMain.Info, StrSearchValue, FormMain.SearchOptions, FormMain.Memo1) = FALSE then
    begin
      sStr2 := StringReplace(StrSearchValue, '&', '&&', [rfReplaceAll]);
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ܂܂ł' + #13#10 +
                            sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Search word can not find.' + #13#10 +
                           '[OK]' + #13#10 +
                            sStr2;
      end;
      ShowMessage(FormMain.StrMsg);
      SetForeGroundWindow(FormFind.Handle);
    end
    else
    begin
      FormMain.Memo1.SelStart  := FormMain.Info.Start;
      FormMain.Memo1.SelLength := FormMain.Info.Length;
      FormMain.Memo1.Perform(EM_SCROLLCARET, 0, 0);
      FormMain.MemoStatus(Sender);
      FormMain.SetFocus;
      if (FormMain.MenuCrLf.Checked = TRUE) or (FormMain.MenuEof.Checked  = TRUE) or
         (FormMain.MenuTab.Checked  = TRUE) or (FormMain.MenuDBCS.Checked = TRUE) then
      begin
        FormMain.Memo1.Invalidate;
      end;
      if CheckBox1.Checked = TRUE then
      begin
        ButtonCancelClick(Sender);
      end
      else
      begin
        Timer2.Enabled := TRUE;
      end;
    end;
  end;

  if StrParentForm = PARENT_FIND_ALL then
  begin
    //I
    ModalResult := mrOK;
  end;

  if StrParentForm = PARENT_FIND_FILE_ALL then
  begin
    //I
    ModalResult := mrOK;
  end;

end;

procedure TFormFind.ButtonCancelClick(Sender: TObject);
begin
  //
  if StrParentForm = PARENT_MAIN then
  begin
    //ݒ
    FormMain.Menu := FormMain.MainMenu1;
    //I
    Close;
  end;

  if StrParentForm = PARENT_FIND_ALL then
  begin
    //I
    Close;
  end;

  if StrParentForm = PARENT_FIND_FILE_ALL then
  begin
    //I
    Close;
  end;

end;

procedure TFormFind.MenuCloseClick(Sender: TObject);
begin
  ButtonCancelClick(Sender);
end;

procedure TFormFind.MenuCopyClick(Sender: TObject);
var
  sStr2: String;
begin
  //擾
  sStr2 := ComboBox1.SelText;

  //Rs[
  Edit1.Text := '';
  Edit1.Text := sStr2;
  Edit1.SelectAll;
  Edit1.CopyToClipboard;
end;

procedure TFormFind.MenuCutClick(Sender: TObject);
var
  iPos1: Integer;
  iLen1: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //擾
  sStr1 := ComboBox1.Text;
  sStr2 := ComboBox1.SelText;

  //Rs[
  Edit1.Text := '';
  Edit1.Text := sStr2;
  Edit1.SelectAll;
  Edit1.CopyToClipboard;

  //c
  iLen1 := Length(sStr2);
  iPos1 := Pos(sStr2, sStr1);
  sStr3 := Copy(sStr1, 1, iPos1-1) + Copy(sStr1, iPos1+iLen1, Length(sStr1));

  //ݒ
  ComboBox1.Text := sStr3;
end;

procedure TFormFind.MenuPasteClick(Sender: TObject);
var
  iPos1: Integer;
  iLen1: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
begin
  //\t
  Edit1.Text := '';
  Edit1.PasteFromClipboard;

  //擾
  sStr1 := ComboBox1.Text;
  sStr2 := ComboBox1.SelText;
  iPos1 := ComboBox1.SelStart;
  iLen1 := Length(sStr2);

  //I͈͂Ȃ
  if Length(sStr2) = 0 then
  begin
    //O
    sStr3 := Copy(sStr1, 1, iPos1);
    //㔼
    sStr4 := Copy(sStr1, iPos1+1, Length(sStr1));
    //ݒ
    ComboBox1.Text := sStr3 + Edit1.Text + sStr4;
  end
  //I͈͂
  else
  begin
    //O
    sStr3 := Copy(sStr1, 1, iPos1);
    //㔼
    sStr4 := Copy(sStr1, iPos1+iLen1+1, Length(sStr1));
    //ݒ
    ComboBox1.Text := sStr3 + Edit1.Text + sStr4;
  end;
end;

procedure TFormFind.MenuSearchNextClick(Sender: TObject);
begin
  if ComboBox1.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ꂪݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Search word is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end
  else
  begin
    ButtonNext.SetFocus;
    ButtonNextClick(Sender);
  end;
end;

procedure TFormFind.MenuSearchPrevClick(Sender: TObject);
begin
  if ComboBox1.Text = '' then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ꂪݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Search word is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end
  else
  begin
    ButtonPrev.SetFocus;
    ButtonPrevClick(Sender);
  end;
end;

procedure TFormFind.MenuSearchNext2Click(Sender: TObject);
begin
    ButtonNextClick(Sender);
end;

procedure TFormFind.MenuSearchPrev2Click(Sender: TObject);
begin
    ButtonPrevClick(Sender);
end;



procedure TFormFind.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
  end
  else
  begin
    StrListKeyMap.Assign(FormMain.StrListKeyMap);
  end;

  //ݒ
  if StrListKeyMap.Count > 0 then
  begin
    SetShortCutNew('1031', FormFind.MenuClose, Sender);
    SetShortCutNew('1102', FormFind.MenuSearchNext, Sender);
    SetShortCutNew('1103', FormFind.MenuSearchPrev, Sender);

    SetShortCutNewFind('1031', FormFind.MenuClose2, Sender);
    SetShortCutNewFind('1102', FormFind.MenuSearchNext2, Sender);
    SetShortCutNewFind('1103', FormFind.MenuSearchPrev2, Sender);
  end;
end;

procedure TFormFind.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    Exit;
  end;
  //ݒ
  sStr3 := sStr16;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

procedure TFormFind.SetShortCutNewFind(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    Exit;
  end;
  //ݒ
  sStr3 := sStr16;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  if (Shift = []) or (Shift = [ssShift]) then
  begin
    if (Key = VK_0) or (Key = VK_1) or (Key = VK_2) or (Key = VK_3) or (Key = VK_4) or
       (Key = VK_5) or (Key = VK_6) or (Key = VK_7) or (Key = VK_8) or (Key = VK_9) or
       (Key = VK_A) or (Key = VK_B) or (Key = VK_C) or (Key = VK_D) or (Key = VK_E) or
       (Key = VK_F) or (Key = VK_G) or (Key = VK_H) or (Key = VK_I) or (Key = VK_J) or
       (Key = VK_K) or (Key = VK_L) or (Key = VK_M) or (Key = VK_N) or (Key = VK_O) or
       (Key = VK_P) or (Key = VK_Q) or (Key = VK_R) or (Key = VK_S) or (Key = VK_T) or
       (Key = VK_U) or (Key = VK_V) or (Key = VK_W) or (Key = VK_X) or (Key = VK_Y) or
       (Key = VK_Z) or
       (Key = VK_COMMA)      or (Key = VK_PIRIOD)     or (Key = VK_SLASH) or
       (Key = VK_BACKSLASH)  or (Key = VK_SEMICOLLON) or (Key = VK_COLLON) or
       (Key = VK_RIGHT_KAGI) or (Key = VK_AT_MARK)    or (Key = VK_LEFT_KAGI) or
       (Key = VK_MINUS) or      (Key = VK_HATTO)      or (Key = VK_YEN )then
    begin
      //ݒ
      Key := 0;
      Shift := [];
      MenuItemName.ShortCut := ShortCut(Key, Shift);
    end
    else
    begin
      //ݒ
      MenuItemName.ShortCut := ShortCut(Key, Shift);
    end;
  end
  else
  begin
    //ݒ
    MenuItemName.ShortCut := ShortCut(Key, Shift);
  end;

end;

procedure TFormFind.Timer2Timer(Sender: TObject);
begin
  Timer2.Enabled := FALSE;
  SetForeGroundWindow(FormFind.Handle);
end;


end.


