unit FindAll;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, HtSearch, Vcl.ComCtrls, ShellApi, MemoExDark, System.UITypes;

function StrCmpLogicalW(psz1, psz2: PWideChar): Integer; stdcall; external 'shlwapi.dll';

const
  FORM_LEFT_SHIFT   = 9;
  FORM_TOP_SHIFT    = 9;
  FORM_WIDTH_SET    = 800;
  FORM_HEIGHT_SET   = 480;
  FORM_MAX          = 'MAX';
  FORM_MIN          = 'MIN';
  FORM_NORMAL       = 'NORMAL';
  FILE_FIND_LINE_MAX = 100000;

type
  TFormFindAll = class(TForm)
    Panel1: TPanel;
    ButtonSearchAll: TButton;
    ButtonCancel: TButton;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuClose: TMenuItem;
    MenuSearch: TMenuItem;
    MenuSearchAll: TMenuItem;
    ButtonCsvText: TButton;
    MenuViewGrid: TMenuItem;
    MenuSearchWord: TMenuItem;
    Timer1: TTimer;
    ButtonSearchPrev: TButton;
    ButtonSearchNext: TButton;
    MenuSearchPrev: TMenuItem;
    MenuSearchNext: TMenuItem;
    Timer6: TTimer;
    ButtonPrev: TButton;
    ButtonNext: TButton;
    MenuMove: TMenuItem;
    MenuJump: TMenuItem;
    MenuTop: TMenuItem;
    MenuPrev: TMenuItem;
    MenuNext: TMenuItem;
    MenuEnd: TMenuItem;
    N1: TMenuItem;
    MenuCommon: TMenuItem;
    MenuKeyBoard: TMenuItem;
    Timer3: TTimer;
    StatusBar2: TStatusBar;
    StatusBar1: TStatusBar;
    MenuView: TMenuItem;
    MenuCrLf: TMenuItem;
    MenuEof: TMenuItem;
    MenuTab: TMenuItem;
    MenuDBCS: TMenuItem;
    ButtonSearchWord: TButton;
    MenuShowButton: TMenuItem;
    ButtonSearchFileAll: TButton;
    MenuSearchFileAll: TMenuItem;
    Memo5: TMemoExDark;
    Memo9: TMemoExDark;
    Memo1: TMemoExDark;
    PopupMenu1: TPopupMenu;
    PopUpCopy: TMenuItem;
    PopUpSelectAll: TMenuItem;
    MenuEdit: TMenuItem;
    MenuCopy: TMenuItem;
    MenuSelectAll: TMenuItem;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuSearchAllClick(Sender: TObject);
    procedure MenuCloseClick(Sender: TObject);
    procedure ButtonSearchAllClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MenuSearchWordClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ButtonSearchPrevClick(Sender: TObject);
    procedure ButtonSearchNextClick(Sender: TObject);
    procedure MenuSearchNextClick(Sender: TObject);
    procedure MenuSearchPrevClick(Sender: TObject);
    procedure Timer6Timer(Sender: TObject);
    procedure ButtonPrevClick(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
    procedure MenuViewGridClick(Sender: TObject);
    procedure ButtonCsvTextClick(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
    procedure MenuTopClick(Sender: TObject);
    procedure MenuPrevClick(Sender: TObject);
    procedure MenuNextClick(Sender: TObject);
    procedure MenuEndClick(Sender: TObject);
    procedure MenuJumpClick(Sender: TObject);
    procedure MenuKeyBoardClick(Sender: TObject);
    procedure SetShortCutKey(Sender: TObject);
    procedure GetFunctionList(SrcList: TStringList; DstList: TStringList; Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure MenuCrLfClick(Sender: TObject);
    procedure MenuEofClick(Sender: TObject);
    procedure MenuTabClick(Sender: TObject);
    procedure MenuDBCSClick(Sender: TObject);
    procedure ButtonSearchWordClick(Sender: TObject);
    procedure MenuShowButtonClick(Sender: TObject);
    procedure MenuSearchFileAllClick(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure Memo9Click(Sender: TObject);
    procedure MemoStatus(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Memo1Click(Sender: TObject);
    procedure MenuCopyClick(Sender: TObject);
    procedure MenuSelectAllClick(Sender: TObject);
    procedure PopUpCopyClick(Sender: TObject);
    procedure PopUpSelectAllClick(Sender: TObject);

  private
    { Private 錾 }
    StrSaveFileName: String;
    StrSearchValue: String;
    StrListText: TstringList;
    StrListLine: TstringList;
    StrListKeyMapCheck1: TStringList;
    StrListKeyMapCheck2: TStringList;
    StrListFile: TStringList;
    StrListFileCol: TStringList;
    StrListFileLine: TStringList;
    StrListFileLineCol: TStringList;
    StrListFileLoad: TStringList;

    StrFormState: String;
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    IntFormShiftX: Integer;
    IntFormShiftY: Integer;
    IntTopLineMemo: Integer;
    BoolKeyMapSame:Boolean;
    StrParentForm: String;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;
    Info: TSearchInfo;
    TabStops: array [0..0] of DWord;
  public
    { Public 錾 }
    StrListKeyMap: TStringList;
    StrListKeyMapOriginal: TStringList;

    procedure InitKeyMap(ExeType: Integer; Sender: TObject);

  end;

var
  FormFindAll: TFormFindAll;

implementation

uses
  Main, Find, Jump, KeyBoard, ViewGrid;

{$R *.dfm}

//explorer
function CompareLogical(List: TStringList; Index1, Index2: Integer): Integer;
begin
  //r
  Result := StrCmpLogicalW(PWideChar(WideString(List[Index1])), PWideChar(WideString(List[Index2])));
end;

//explorer
//t@C̕Ń\[g
//0 0 0 0 0 C:\123\456.jpg
function CompareLogical2(List: TStringList; Index1, Index2: Integer): Integer;
var
  sStr11: String;
  sStr12: String;
begin
  //t@C𒊏o
  sStr11 := Copy(List[Index1], 11, Length(List[Index1]));

  //t@C𒊏o
  sStr12 := Copy(List[Index2], 11, Length(List[Index2]));

  //r
  Result := StrCmpLogicalW(PWideChar(WideString(sStr11)), PWideChar(WideString(sStr12)));
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormFindAll.ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //
  end
  //ENTER
  else if (Shift = []) and (key = VK_RETURN) then
  begin
    ButtonSearchAllClick(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFindAll.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormFindAll.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormFindAll.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;

  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormFindAll.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormFindAll', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormFindAll', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormFindAll', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormFindAll', 'Left',   FormFindAll.Left);
    IniFile.WriteInteger('FormFindAll', 'Top',    FormFindAll.Top);
    IniFile.WriteInteger('FormFindAll', 'Width',  FormFindAll.Width);
    IniFile.WriteInteger('FormFindAll', 'Height', FormFindAll.Height);
  end;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ۑ
  IniFile.WriteBool   ('FindAll', 'CrLf',  MenuCrlf.Checked);
  IniFile.WriteBool   ('FindAll', 'EOF',   MenuEof.Checked);
  IniFile.WriteBool   ('FindAll', 'Tab',   MenuTab.Checked);
  IniFile.WriteBool   ('FindAll', 'DBCS',  MenuDBCS.Checked);
  //j
  IniFile.Free;

  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormFindAll.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormFindAll.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //m
  StrListText := TStringList.Create;
  StrListLine := TStringList.Create;
  StrListKeyMap := TStringList.Create;
  StrListKeyMapOriginal := TStringList.Create;
  StrListKeyMapCheck1 := TStringList.Create;
  StrListKeyMapCheck2 := TStringList.Create;
  StrListFile := TStringList.Create;
  StrListFileCol := TStringList.Create;
  StrListFileLine := TStringList.Create;
  StrListFileLineCol := TStringList.Create;
  StrListFileLoad := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  FormMain.StrSearchValue   := IniFile.ReadString ('Options',     'SearchWord', '');
  StrSaveFileName           := IniFile.ReadString ('FileName',    'SearchAll',  '');
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  StrParentForm := IniFile.ReadString('FormFind', 'Parent', PARENT_MAIN);
  //j
  IniFile.Free;

  if StrParentForm = PARENT_FIND_ALL then
  begin
    ButtonSearchAll.Enabled     := TRUE;
    ButtonSearchFileAll.Enabled := FALSE;
    MenuSearchAll.Enabled       := TRUE;
    MenuSearchFileAll.Enabled   := FALSE;
  end;
  if StrParentForm = PARENT_FIND_FILE_ALL then
  begin
    ButtonSearchAll.Enabled     := FALSE;
    ButtonSearchFileAll.Enabled := TRUE;
    MenuSearchAll.Enabled       := FALSE;
    MenuSearchFileAll.Enabled   := TRUE;
  end;

  //ݒ
  Memo1.Align := alClient;
  Memo1.Lines.Clear;
  //ݒ
  Memo9.Lines.Clear;
  //ݒ
  Memo5.Lines.Clear;
  Memo5.WordWrap    := FALSE;
  Memo5.WantReturns := FALSE;
  Memo5.WantTabs    := FALSE;
  Memo5.Width       := 1;

  //
  Timer1.Enabled := FALSE;
  Timer3.Enabled := FALSE;
  Timer6.Enabled := FALSE;

  //
  Memo1.Lines.Clear;
  Memo1.WordWrap := FALSE;
  Memo9.Lines.Clear;
  Memo9.WordWrap := FALSE;

  //f
  Memo1.Font  := FormMain.Memo1.Font;
  Memo1.Color := FormMain.Memo1.Color;
  Memo9.Font  := FormMain.Memo9.Font;
  Memo9.Color := FormMain.Memo9.Color;
  //f
  Memo1.EditMarks.EofMark.Color     := FormMain.Memo1.EditMarks.EofMark.Color;
  Memo1.EditMarks.SpaceMark.Color   := FormMain.Memo1.EditMarks.SpaceMark.Color;
  Memo1.EditMarks.CrlfMark.Color    := FormMain.Memo1.EditMarks.CrlfMark.Color;
  Memo1.EditMarks.TabMark.Color     := FormMain.Memo1.EditMarks.TabMark.Color;
  //f
  Memo1.ShiftRet  := FormMain.Memo1.ShiftRet;
  Memo1.ShiftEof  := FormMain.Memo1.ShiftEof;
  Memo1.ShiftTab  := FormMain.Memo1.ShiftTab;
  Memo1.ShiftDBCS := FormMain.Memo1.ShiftDbcs;

  //
  if FormMain.IntVclStyle = 0 then
  begin
    Memo1.DarkMode := FALSE;
    Memo9.DarkMode := FALSE;
  end
  else
  begin
    Memo1.DarkMode := TRUE;
    Memo9.DarkMode := TRUE;
  end;
  if      FormMain.IntVclStyle = 1 then
  begin
    Memo1.DarkBackColor := FormMain.FTextColorCarbon;
    Memo9.DarkBackColor := FormMain.FTextColorCarbon;
  end
  else if FormMain.IntVclStyle = 2 then
  begin
    Memo1.DarkBackColor := FormMain.FTextColorCharcoal;
    Memo9.DarkBackColor := FormMain.FTextColorCharcoal;
  end
  else if FormMain.IntVclStyle = 3 then
  begin
    Memo1.DarkBackColor := FormMain.FTextColorDark;
    Memo9.DarkBackColor := FormMain.FTextColorDark;
  end
  else
  begin
    //
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  MenuCrlf.Checked             :=          IniFile.ReadBool   ('FindAll', 'CrLf',  FALSE);
  MenuEof.Checked              :=          IniFile.ReadBool   ('FindAll', 'EOF',   FALSE);
  MenuTab.Checked              :=          IniFile.ReadBool   ('FindAll', 'Tab',   FALSE);
  MenuDBCS.Checked             :=          IniFile.ReadBool   ('FindAll', 'DBCS',  FALSE);
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //{^\
  MenuShowButton.Checked := IniFile.ReadBool  ('FindAll', 'ShowButton', FALSE);
  if MenuShowButton.Checked = TRUE then
  begin
    Panel1.Visible         := TRUE;
  end
  else
  begin
    Panel1.Visible         := FALSE;
  end;
  //j
  IniFile.Free;

  //f
  if MenuCrLf.Checked = TRUE then
  begin
    Memo1.EditMarks.CrlfMark.Enabled := TRUE;
  end
  else
  begin
    Memo1.EditMarks.CrlfMark.Enabled := FALSE;
  end;

  if MenuEof.Checked = TRUE then
  begin
    Memo1.EditMarks.EofMark.Enabled := TRUE;
  end
  else
  begin
    Memo1.EditMarks.EofMark.Enabled := FALSE;
  end;

  if MenuTab.Checked = TRUE then
  begin
    Memo1.EditMarks.TabMark.Enabled := TRUE;
  end
  else
  begin
    Memo1.EditMarks.TabMark.Enabled := FALSE;
  end;

  if MenuDBCS.Checked = TRUE then
  begin
    Memo1.EditMarks.SpaceMark.Enabled := TRUE;
  end
  else
  begin
    Memo1.EditMarks.SpaceMark.Enabled := FALSE;
  end;

  //f
  if FormMain.MenuTab2.Checked = FALSE then
  begin
    TabStops[0] := 4*2;
    Memo1.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  end;
  if FormMain.MenuTab4.Checked = FALSE then
  begin
    TabStops[0] := 4*4;
    Memo1.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  end;
  if FormMain.MenuTab6.Checked = FALSE then
  begin
    TabStops[0] := 4*6;
    Memo1.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  end;
  if FormMain.MenuTab8.Checked = FALSE then
  begin
    TabStops[0] := 4*8;
    Memo1.Perform(EM_SETTABSTOPS, 1, Longint(@TabStops));
  end;


end;

procedure TFormFindAll.FormDestroy(Sender: TObject);
begin
  //j
  StrListText.Free;
  StrListLine.Free;
  StrListKeyMap.Free;
  StrListKeyMapOriginal.Free;
  StrListKeyMapCheck1.Free;
  StrListKeyMapCheck2.Free;
  StrListFile.Free;
  StrListFileCol.Free;
  StrListFileLine.Free;
  StrListFileLineCol.Free;
  StrListFileLoad.Free;
end;

procedure TFormFindAll.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
  sStr1: String;
  StrList1: TStringList;
begin
  //FormKeyDowñCxgݒ肷
  FormFindAll.KeyPreview := TRUE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  FormPosLeft   := IniFile.ReadInteger('FormFindAll', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormFindAll', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormFindAll', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormFindAll', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormFindAll', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormFindAll.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormFindAll.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormFindAll.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormFindAll.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  InitKeyMap(0, Sender);

  //m
  StrList1 := TStringList.Create;
  //t@CǍ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FINDALL_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    //Ǎ
    StrList1.LoadFromFile(sStr1, TEncoding.Unicode);
    //ڐ
    if StrList1.Count = StrListKeyMapOriginal.Count then
    begin
      //@\擾
      GetFunctionList(StrList1,              StrListKeyMapCheck1, Sender);
      GetFunctionList(StrListKeyMapOriginal, StrListKeyMapCheck2, Sender);
      //Ƃ肠ڐ𓯂ɂĂ
      BoolKeyMapSame := TRUE;
      //ǂ`FbN
      for iRow1 := 0 to StrListKeyMapCheck2.Count-1 do
      begin
        //Ⴄ
        if StrListKeyMapCheck1.Strings[iRow1] <> StrListKeyMapCheck2.Strings[iRow1] then
        begin
          //Ⴄ
          BoolKeyMapSame := FALSE;
          //f
          Break;
        end;
      end;

      //
      if BoolKeyMapSame = FALSE then
      begin
        //XV
        StrListKeyMap.Assign(StrListKeyMapOriginal);
        //ۑ
        StrListKeyMap.SaveToFile(sStr1, TEncoding.Unicode);
      end;
    end
    else
    begin
      //XV
      StrListKeyMap.Assign(StrListKeyMapOriginal);
      //ۑ
      StrListKeyMap.SaveToFile(sStr1, TEncoding.Unicode);
      //ڐႤ
      BoolKeyMapSame := FALSE;
    end;
  end
  else
  begin
    //ۑ
    StrListKeyMap.Assign(StrListKeyMapOriginal);
    StrListKeyMap.SaveToFile(sStr1, TEncoding.Unicode);
    //ڐ
    BoolKeyMapSame := TRUE;
  end;
  //j
  StrList1.Free;

  //ݒ
  SetShortCutKey(Sender);

  //f
  sStr1 := ChangeFileExt(Application.ExeName, '.ini');
  if FileExists(sStr1) = TRUE then
  begin
    //m
    IniFile := TIniFile.Create(sStr1);
    //sԍ
    Memo9.Width  := StrToInt(IntToStr(IniFile.ReadInteger('Editor', 'LineWidth',  80)));
    //j
    IniFile.Free;
  end
  else
  begin
    //sԍ
    Memo9.Width  := 80;
  end;

  //
  IntFormShiftX   := 0;
  IntFormShiftY   := 0;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));

  //Xe[^Xo[
  if IniFile.ReadBool('StatusBar', 'PositionTop', TRUE) = TRUE then
  begin
    StatusBar2.Visible := TRUE;
  end
  else
  begin
    StatusBar2.Visible := FALSE;
  end;
  if IniFile.ReadBool('StatusBar', 'PositionBottom', TRUE) = TRUE then
  begin
    if MenuShowButton.Checked = TRUE then
    begin
      Panel1.Visible := FALSE;
      StatusBar1.Visible := TRUE;
      Panel1.Visible := TRUE;
    end
    else
    begin
      StatusBar1.Visible := TRUE;
    end;
  end
  else
  begin
    StatusBar1.Visible := FALSE;
  end;

   //j
  IniFile.Free;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FindAll.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormFindAll, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormFindAll, StrLanguageFileName, Sender);
  end;

  //
  Timer6.Enabled := TRUE;
  //bZ[W\
  if BoolKeyMapSame = FALSE then
  begin
    //L[{[h
    Timer3.Enabled := TRUE;
  end
  else
  begin
    //
    Timer1.Enabled := TRUE;
  end;
end;

procedure TFormFindAll.FormResize(Sender: TObject);
var
  iWidth1: Integer;
begin
  //f
  iWidth1      := FormFindAll.Width - 700;
  StatusBar1.Panels.Items[0].Width := iWidth1;
  StatusBar1.Panels.Items[1].Width := 100;
  StatusBar1.Panels.Items[2].Width := 100;
  StatusBar1.Panels.Items[3].Width := 100;
  StatusBar1.Panels.Items[4].Width := 180;
  StatusBar1.Panels.Items[5].Width := 120;
  StatusBar1.Panels.Items[6].Width := 100;
  StatusBar2.Panels.Items[0].Width := iWidth1;
  StatusBar2.Panels.Items[1].Width := 100;
  StatusBar2.Panels.Items[2].Width := 100;
  StatusBar2.Panels.Items[3].Width := 100;
  StatusBar2.Panels.Items[4].Width := 180;
  StatusBar2.Panels.Items[5].Width := 120;
  StatusBar2.Panels.Items[6].Width := 100;
end;

procedure TFormFindAll.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //ENTER
  else if (Shift = []) and (key = VK_RETURN) then
  begin
    //
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormFindAll.MenuSearchNextClick(Sender: TObject);
var
  sStr2: String;
begin
  //
  if (Memo1.Lines.Count = 0) or (Memo9.Lines.Count = 0) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eLXgǂݍ܂Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Text is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //s
  if StrSearchValue <> '' then
  begin
    //\
    StatusBar1.Panels.Items[0].Text := StrSearchValue;
    StatusBar2.Panels.Items[0].Text := StrSearchValue;

    //ݒ
    FormMain.SearchOptions :=  FormMain.SetOptions('', SEARCH_NEXT);
    // ƑO͈قȂ
    Info.Start := Memo1.SelStart + Memo1.SelLength + 1;
    if HtSearch.SearchText2(PWideChar(Memo1.Lines.Text), Info, StrSearchValue, FormMain.SearchOptions, Memo1) = FALSE then
    begin
      sStr2 := StringReplace(StrSearchValue, '&', '&&', [rfReplaceAll]);
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ܂܂ł' + #13#10 +
                            sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Search word can not find.' + #13#10 +
                           '[OK]' + #13#10 +
                            sStr2;
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else
    begin
      Memo1.SelStart := Info.Start;
      Memo1.SelLength := Info.Length;
      Memo1.Perform(EM_SCROLLCARET, 0, 0);
    end;

    //tH[JXݒ
    Memo1.SetFocus;

    //XV
    MemoStatus(Sender);
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ꂪݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Search word is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
end;

procedure TFormFindAll.MenuSearchPrevClick(Sender: TObject);
var
  sStr2: String;
begin
  //
  if (Memo1.Lines.Count = 0) or (Memo9.Lines.Count = 0) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eLXgǂݍ܂Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Text is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //s
  if StrSearchValue <> '' then
  begin
    //\
    StatusBar1.Panels.Items[0].Text := StrSearchValue;
    StatusBar2.Panels.Items[0].Text := StrSearchValue;

    //ݒ
    FormMain.SearchOptions :=  FormMain.SetOptions('', SEARCH_PREV);
    Info.Start := Memo1.SelStart;
    //
    if HtSearch.SearchText1(PWideChar(Memo1.Lines.Text), Info, StrSearchValue, FormMain.SearchOptions, Memo1) = FALSE then
    begin
      sStr2 := StringReplace(StrSearchValue, '&', '&&', [rfReplaceAll]);
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ܂܂ł' + #13#10 +
                            sStr2;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Search word can not find.' + #13#10 +
                           '[OK]' + #13#10 +
                            sStr2;
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else
    begin
      Memo1.SelStart := Info.Start;
      Memo1.SelLength := Info.Length;
      Memo1.Perform(EM_SCROLLCARET, 0, 0);
    end;
    //tH[JXݒ
    Memo1.SetFocus;

    //XV
    MemoStatus(Sender);
  end
  else
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ꂪݒ肳Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Search word is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;
end;

procedure TFormFindAll.Memo9Click(Sender: TObject);
begin
  Memo1.SetFocus;
end;

procedure TFormFindAll.MenuCloseClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormFindAll.MenuCopyClick(Sender: TObject);
begin
  //I͈͂΃Rs[
  if Memo1.SelLength > 0 then
  begin
    //Nbv
    Memo1.CopyToClipboard;
  end;
end;

procedure TFormFindAll.MenuViewGridClick(Sender: TObject);
var
  sStr2: String;
  iRow1: Integer;
  StrList1: TstringList;
  IniFile: TIniFile;
begin
  //
  if (Memo1.Lines.Count = 0) or (Memo9.Lines.Count = 0) then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : eLXgǂݍ܂Ă܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Text is empty.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //ۑ
  sStr2 := ExtractFilePath(ParamStr(0)) + FIND_ALL_TXT;
  StrList1 := TStringList.Create;
  for iRow1 := 0 to Memo1.Lines.Count-1 do
  begin
    StrList1.Add(Memo9.Lines.Strings[iRow1] + FormMain.StrCsvSeparater + Memo1.Lines.Strings[iRow1]);
  end;
  StrList1.SaveToFile(sStr2, TEncoding.Unicode);
  StrList1.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteString('FormViewGrid', 'Parent', PARENT_FIND_ALL);
  //j
  IniFile.Free;

  //
  FormViewGrid := TFormViewGrid.Create(Application);
  try
    //\
    FormViewGrid.ShowModal;
  finally
    //j
    FormViewGrid.Free;
  end;
end;

procedure TFormFindAll.MenuJumpClick(Sender: TObject);
var
  IniFile: TIniFile;
  iPos1: Integer;
  iRow1: Integer;
  iLine1: Integer;
  iLine2: Integer;
  bResult: Boolean;
begin
  //
  FormJump := TFormJump.Create(Application);
  try
    //\
    if FormJump.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormJump.Free;
  end;

  //
  if bResult = TRUE then
  begin
    //m
    IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
    //擾
    iPos1 :=IniFile.ReadInteger('Editor', 'Jump',  1) - 1;
    //j
    IniFile.Free;

    //
    if iPos1 < 0 then
    begin
      iRow1 := 0;
    end
    else if iPos1 > (Memo1.Lines.Count-1) then
    begin
      iRow1 := Memo1.Lines.Count-1
    end
    else
    begin
      iRow1 := iPos1;
    end;

    //݂̃J[\̂s
    iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
    //ړs
    iLine2 := iRow1;
    //ړ
    Memo1.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
    Memo1.SelStart := Memo1.Perform(EM_LINEINDEX, iLine2, 0);
    Memo1.SetFocus;
  end;

end;


procedure TFormFindAll.MenuKeyBoardClick(Sender: TObject);
var
  bResult: Boolean;
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteString('FormKeyBoard', 'Parent', PARENT_FIND_ALL);
  //j
  IniFile.Free;

  //
  FormKeyBoard := TFormKeyBoard.Create(Application);
  try
    //\
    if FormKeyBoard.ShowModal = mrOK then
    begin
      bResult := TRUE;
    end
    else
    begin
      bResult := FALSE;
    end;
  finally
    //j
    FormKeyBoard.Free;
  end;

  //
  if bResult = TRUE then
  begin
    //ݒ
    SetShortCutKey(Sender);
  end;

end;

procedure TFormFindAll.MenuTopClick(Sender: TObject);
var
  iLine1: Integer;
begin
    //݂̃J[\̂s
    iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
    //݂̍s߂
    Memo1.Perform(EM_LINESCROLL, 0, -iLine1);
    //ړ
    Memo1.SelStart := 0;
    Memo1.SetFocus;
end;

procedure TFormFindAll.PopUpCopyClick(Sender: TObject);
begin
  MenuCopyClick(Sender);
end;

procedure TFormFindAll.PopUpSelectAllClick(Sender: TObject);
begin
  MenuSelectAllClick(Sender);
end;

procedure TFormFindAll.MenuNextClick(Sender: TObject);
var
  iLine1: Integer;
  iLine2: Integer;
begin
    //݂̃J[\̂s
    iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
    //ړs
    iLine2 := iLine1 + FormMain.IntScroll3;
    if iLine2 > Memo1.Lines.Count-1 then
    begin
      iLine2 := Memo1.Lines.Count-1;
    end;
    //ړ
    Memo1.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
    Memo1.SelStart := Memo1.Perform(EM_LINEINDEX, iLine2, 0);
    Memo1.SetFocus;
end;

procedure TFormFindAll.MenuPrevClick(Sender: TObject);
var
  iLine1: Integer;
  iLine2: Integer;
begin
    //݂̃J[\̂s
    iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
    //ړs
    iLine2 := iLine1 - FormMain.IntScroll3;
    if iLine2 < 0 then
    begin
      iLine2 := 0;
    end;
    //ړ
    Memo1.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
    Memo1.SelStart := Memo1.Perform(EM_LINEINDEX, iLine2, 0);
    Memo1.SetFocus;
end;

procedure TFormFindAll.MenuEndClick(Sender: TObject);
var
  iLine1: Integer;
  iLine2: Integer;
begin
    //݂̃J[\̂s
    iLine1 := Memo1.Perform(EM_LINEFROMCHAR, Memo1.SelStart, 0);
    //ړs
    iLine2 := Memo1.Perform(EM_GETLINECOUNT, 0, 0);
    //ړ
    Memo1.Perform(EM_LINESCROLL, 0, iLine2 - iLine1);
    Memo1.SelStart := Memo1.Perform(EM_LINEINDEX, iLine2-1, 0);
    Memo1.SetFocus;
end;

procedure TFormFindAll.MenuSearchAllClick(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
  iIndex1: Integer;
  StrStream1: TStringStream;
  StrStream2: TStringStream;
  bResult: Boolean;
begin
  //\Ăꍇ͈U
  if FormFind.Visible = TRUE then
  begin
    FormFind.Close;
  end;

  //\
  if FormFind.ShowModal = mrOK then
  begin
    bResult := TRUE;
  end
  else
  begin
    bResult := FALSE;
  end;

  //
  if bResult = TRUE then
  begin
    //m
    IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
    //Ǎ
    iIndex1  := IniFile.ReadInteger('Editor', 'LineZero',    1);
    //Ǎ
    StrSearchValue := IniFile.ReadString ('Options',     'SearchWord',     '');
    //j
    IniFile.Free;

    //\
    StatusBar1.Panels.Items[0].Text := StrSearchValue;
    StatusBar2.Panels.Items[0].Text := StrSearchValue;

    //IvVݒ肷
    FormMain.SearchOptions := FormMain.SetOptions('', SEARCH_NEXT);
    //
    StrListText.Clear;
    StrListLine.Clear;
    for iRow1 := 0 to FormMain.Memo1.Lines.Count-1 do
    begin
      //
      Info.Start  := 0;
      Info.Length := 0;
      if HtSearch.SearchText(PWideChar(FormMain.Memo1.Lines.Strings[iRow1]), Info, StrSearchValue, FormMain.SearchOptions) = FALSE then
      begin
        ;
      end
      else
      begin
        if iIndex1 = 0 then
        begin
          StrListLine.Add(Format('%6d',  [iRow1+1]));
          StrListText.Add(FormMain.Memo1.Lines.Strings[iRow1]);
        end
        else
        begin
          StrListLine.Add(Format('%.6d', [iRow1+1]));
          StrListText.Add(FormMain.Memo1.Lines.Strings[iRow1]);
        end;
      end;
    end;

    //t@C܂̓Xg[͍ɕ\\
    StrStream1 := TStringStream.Create(StrListLine.Text);
    Memo9.Lines.LoadFromStream(StrStream1);
    StrStream1.Free;
    Memo9.SelStart := 0;
    //t@C܂̓Xg[͍ɕ\\
    StrStream2 := TStringStream.Create(StrListText.Text);
    Memo1.Lines.LoadFromStream(StrStream2);
    StrStream2.Free;
    Memo1.SelStart := 0;

//  Memo1.Lines.BeginUpdate;
//  Memo1.lines.Assign(StrListText);
//  Memo1.Lines.EndUpdate;
//  Memo1.SelStart := 0;
//  Memo9.Lines.BeginUpdate;
//  Memo9.lines.Assign(StrListLine);
//  Memo9.Lines.EndUpdate;
//  Memo9.SelStart := 0;

    //tH[JXݒ
    Memo1.SetFocus;

    //ŏ
    MenuSearchNextClick(Sender);

    //XV
    MemoStatus(Sender);

    //\
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : ܂';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Search word had done.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormFindAll.MenuSearchWordClick(Sender: TObject);
var
  IniFile: TIniFile;
  bResult: Boolean;
begin

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteString('Options',  'SearchWord', StrSearchValue);
  IniFile.WriteString('FormFind', 'Parent',     PARENT_FIND_ALL);
  //j
  IniFile.Free;

  //\Ăꍇ͈U
  if FormFind.Visible = TRUE then
  begin
    FormFind.Close;
  end;

  //\
  if FormFind.ShowModal = mrOK then
  begin
    bResult := TRUE;
  end
  else
  begin
    bResult := FALSE;
  end;

  //
  if bResult = TRUE then
  begin
    MenuSearchNextClick(Sender);
  end;
end;

procedure TFormFindAll.MenuSelectAllClick(Sender: TObject);
begin
  //
  if Memo1.Text <> '' then
  begin
    //SI
    Memo1.SelectAll;
  end;
end;

procedure TFormFindAll.MenuShowButtonClick(Sender: TObject);
var
  IniFile:TIniFile;
begin
  if MenuShowButton.Checked = FALSE then
  begin
    MenuShowButton.Checked := TRUE;
    Panel1.Visible         := TRUE;
  end
  else
  begin
    MenuShowButton.Checked := FALSE;
    Panel1.Visible         := FALSE;
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool  ('FindAll', 'ShowButton', MenuShowButton.Checked);
  //j
  IniFile.Free;
end;

procedure TFormFindAll.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := FALSE;

  if StrParentForm = PARENT_FIND_ALL then
  begin
    MenuSearchAllClick(Sender);
  end;
  if StrParentForm = PARENT_FIND_FILE_ALL then
  begin
    MenuSearchFileAllClick(Sender);
  end;
end;

procedure TFormFindAll.Timer3Timer(Sender: TObject);
begin
  //Zbg
  Timer3.Enabled := FALSE;
  //ݒ
  if BoolJapanese = TRUE then
  begin
    FormMain.StrMsg := 'Information : L[{[hݒeύXɂȂ̂ŏ܂';
  end
  else
  begin
    FormMain.StrMsg := 'Information : Keyboard map had initialized, because of keyboard map had updated.' +
              '[OK]';
  end;
  ShowMessage(FormMain.StrMsg);
end;

procedure TFormFindAll.Timer6Timer(Sender: TObject);
var
  iLine5: Integer;
  iLine6: Integer;
begin

  if Memo1.Lines.Count > 0 then
  begin
    //ʂ̍ŏs
    iLine5 := Memo1.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
    //OƈႤ
    if iLine5 <> IntTopLineMemo then
    begin
      //ʂ̍ŏs
      iLine6 := Memo9.Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
      //ړ
      Memo9.Perform(EM_LINESCROLL, 0, iLine5 - iLine6);
    end;
    IntTopLineMemo := iLine5;
  end;
end;

procedure TFormFindAll.ButtonSearchAllClick(Sender: TObject);
begin
  MenuSearchAllClick(Sender);
end;

procedure TFormFindAll.ButtonSearchNextClick(Sender: TObject);
begin
  MenuSearchNextClick(Sender);
end;

procedure TFormFindAll.ButtonSearchPrevClick(Sender: TObject);
begin
  MenuSearchPrevClick(Sender);
end;

procedure TFormFindAll.ButtonSearchWordClick(Sender: TObject);
begin
  MenuSearchWordClick(Sender);
end;

procedure TFormFindAll.ButtonCsvTextClick(Sender: TObject);
begin
  MenuViewGridClick(Sender);
end;

procedure TFormFindAll.ButtonPrevClick(Sender: TObject);
begin
  MenuPrevClick(Sender);
end;

procedure TFormFindAll.ButtonNextClick(Sender: TObject);
begin
  MenuNextClick(Sender);
end;

procedure TFormFindAll.ButtonCancelClick(Sender: TObject);
begin
  MenuCloseClick(Sender);
end;

procedure TFormFindAll.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    Exit;
  end;
  //ݒ
  sStr3 := sStr16;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

procedure TFormFindAll.InitKeyMap(ExeType: Integer; Sender: TObject);
var
  sStr1: String;
  sStr2: String;
begin
  //NA
  StrListKeyMapOriginal.Clear;

  //File
  sStr1 :=                FormFindAll.MenuViewGrid.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1001');

  sStr1 :=                FormFindAll.MenuClose.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_FILE + #09 + sStr1 + #09 + sStr2 + #09 + '1002');

  //Search
  sStr1 :=                FormFindAll.MenuSearchWord.Caption;
  if ExeType = 0 then
  begin
    sStr2 := ShortCutToText(VK_F);
  end
  else
  begin
    sStr2 := ShortCutToText(scCtrl + VK_F);
  end;
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_SEARCH + #09 + sStr1 + #09 + sStr2 + #09 + '1101');

  sStr1 :=                FormFindAll.MenuSearchNext.Caption;
  if ExeType = 0 then
  begin
    sStr2 := ShortCutToText(VK_V);
  end
  else
  begin
    sStr2 := ShortCutToText(VK_F3);
  end;
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_SEARCH + #09 + sStr1 + #09 + sStr2 + #09 + '1102');

  sStr1 :=                FormFindAll.MenuSearchPrev.Caption;
  if ExeType = 0 then
  begin
    sStr2 := ShortCutToText(VK_T);
  end
  else
  begin
    sStr2 := ShortCutToText(scShift + VK_F3);
  end;
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_SEARCH + #09 + sStr1 + #09 + sStr2 + #09 + '1103');

  sStr1 :=                FormFindAll.MenuSearchAll.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_SEARCH + #09 + sStr1 + #09 + sStr2 + #09 + '1104');

  sStr1 :=                FormFindAll.MenuSearchFileAll.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_SEARCH + #09 + sStr1 + #09 + sStr2 + #09 + '1105');

  //Move
  sStr1 :=                FormFindAll.MenuJump.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1201');

  sStr1 :=                FormFindAll.MenuTop.Caption;
  if ExeType = 0 then
  begin
    sStr2 := ShortCutToText(VK_HOME);
  end
  else
  begin
    sStr2 := ShortCutToText(scCtrl + VK_HOME);
  end;
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1202');

  sStr1 :=                FormFindAll.MenuPrev.Caption;
  if ExeType = 0 then
  begin
    sStr2 := ShortCutToText(VK_PRIOR);
  end
  else
  begin
    sStr2 := ShortCutToText(VK_PRIOR);
  end;
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1203');

  sStr1 :=                FormFindAll.MenuNext.Caption;
  if ExeType = 0 then
  begin
    sStr2 := ShortCutToText(VK_NEXT);
  end
  else
  begin
    sStr2 := ShortCutToText(VK_NEXT);
  end;
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1204');

  sStr1 :=                FormFindAll.MenuEnd.Caption;
  if ExeType = 0 then
  begin
    sStr2 := ShortCutToText(VK_END);
  end
  else
  begin
    sStr2 := ShortCutToText(scCtrl + VK_END);
  end;
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_MOVE + #09 + sStr1 + #09 + sStr2 + #09 + '1205');

  //View
  sStr1 :=                FormFindAll.MenuCrLf.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1301');

  sStr1 :=                FormFindAll.MenuEof.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1302');

  sStr1 :=                FormFindAll.MenuTab.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1303');

  sStr1 :=                FormFindAll.MenuDBCS.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_VIEW + #09 + sStr1 + #09 + sStr2 + #09 + '1304');

  //Common
  sStr1 :=                FormFindAll.MenuKeyBoard.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_COMMON + #09 + sStr1 + #09 + sStr2 + #09 + '1401');

  sStr1 :=                FormFindAll.MenuShowButton.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_COMMON + #09 + sStr1 + #09 + sStr2 + #09 + '1402');

  //Edit
  sStr1 :=                FormFindAll.MenuCopy.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_EDIT + #09 + sStr1 + #09 + sStr2 + #09 + '1501');

  sStr1 :=                FormFindAll.MenuSelectAll.Caption;
  sStr2 := ShortCutToText(0);
  StrListKeyMapOriginal.Add(SHORTCUT_ITEM_EDIT + #09 + sStr1 + #09 + sStr2 + #09 + '1502');

end;

procedure TFormFindAll.SetShortCutKey(Sender: TObject);
var
  sStr1: String;
begin
  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FINDALL_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
  end
  //t@CȂꍇ́AftHgŐݒ肳ĂeɂȂĂ
  else
  begin
    StrListKeyMap.SaveToFile(sStr1, TEncoding.Unicode);
  end;

  //ݒ
  if StrListKeyMap.Count > 0 then
  begin
    SetShortCutNew('1001', MenuViewGrid, Sender);
    SetShortCutNew('1002', MenuClose, Sender);

    SetShortCutNew('1101', MenuSearchWord, Sender);
    SetShortCutNew('1102', MenuSearchNext, Sender);
    SetShortCutNew('1103', MenuSearchPrev, Sender);
    SetShortCutNew('1104', MenuSearchAll, Sender);
    SetShortCutNew('1105', MenuSearchFileAll, Sender);

    SetShortCutNew('1201', MenuJump, Sender);
    SetShortCutNew('1202', MenuTop, Sender);
    SetShortCutNew('1203', MenuPrev, Sender);
    SetShortCutNew('1204', MenuNext, Sender);
    SetShortCutNew('1205', MenuEnd, Sender);

    SetShortCutNew('1301', MenuCrLf, Sender);
    SetShortCutNew('1302', MenuEof, Sender);
    SetShortCutNew('1303', MenuTab, Sender);
    SetShortCutNew('1304', MenuDBCS, Sender);

    SetShortCutNew('1401', MenuKeyBoard, Sender);
    SetShortCutNew('1402', MenuShowButton, Sender);

    SetShortCutNew('1501', MenuCopy, Sender);
    SetShortCutNew('1502', MenuSelectAll, Sender);
  end;
end;

procedure TFormFindAll.GetFunctionList(SrcList: TStringList; DstList: TStringList;Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
begin
  //NA
  DstList.Clear;
  DstList.Sorted := TRUE;
  //擾
  for iRow1 := 0 to SrcList.Count-1 do
  begin
    //擾
    sStr11 := SrcList.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ǉ
    DstList.Add(sStr17);
  end;
end;

procedure TFormFindAll.MenuDBCSClick(Sender: TObject);
begin
  if MenuDBCS.Checked = FALSE then
  begin
    MenuDBCS.Checked := TRUE;
  end
  else
  begin
    MenuDBCS.Checked := FALSE;
  end;
  if Memo1.ReadOnly = TRUE then
  begin
    //f
    Memo1.EditMarks.SpaceMark.Enabled := MenuDBCS.Checked;
  end;
end;

procedure TFormFindAll.MenuCrLfClick(Sender: TObject);
begin
  if MenuCrLf.Checked = FALSE then
  begin
    MenuCrLf.Checked := TRUE;
  end
  else
  begin
    MenuCrLf.Checked := FALSE;
  end;
  if Memo1.ReadOnly = TRUE then
  begin
    //f
    Memo1.EditMarks.CrLfMark.Enabled := MenuCrLf.Checked;
  end;
end;

procedure TFormFindAll.MenuEofClick(Sender: TObject);
begin
  if MenuEof.Checked = FALSE then
  begin
    MenuEof.Checked := TRUE;
  end
  else
  begin
    MenuEof.Checked := FALSE;
  end;
  if Memo1.ReadOnly = TRUE then
  begin
    //f
    Memo1.EditMarks.EofMark.Enabled := MenuEof.Checked;
  end;
end;

procedure TFormFindAll.MenuTabClick(Sender: TObject);
begin
  if MenuTab.Checked = FALSE then
  begin
    MenuTab.Checked := TRUE;
  end
  else
  begin
    MenuTab.Checked := FALSE;
  end;
  if Memo1.ReadOnly = TRUE then
  begin
    //f
    Memo1.EditMarks.TabMark.Enabled := MenuTab.Checked;
  end;
end;

procedure TFormFindAll.MenuSearchFileAllClick(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
  iRow2: Integer;
  iIndex1: Integer;
  iPos1: Integer;
  iLine1: Integer;
  iStart1: Integer;
  StrStream1: TStringStream;
  bResult: Boolean;
  File1: TSearchRec;
  sStr1: String;
  sStr3: String;
  StrList2: TStringList;
  bError1: Boolean;
  bError2: Boolean;
  wRet8: Word;
begin
  //\Ăꍇ͈U
  if FormFind.Visible = TRUE then
  begin
    FormFind.Close;
  end;

  //\
  if FormFind.ShowModal = mrOK then
  begin
    bResult := TRUE;
  end
  else
  begin
    bResult := FALSE;
  end;

  //
  if bResult = TRUE then
  begin

    //m
    IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
    //Ǎ
    iIndex1  := IniFile.ReadInteger('Editor', 'LineZero',    1);
    //Ǎ
    StrSearchValue := IniFile.ReadString ('Options',     'SearchWord',     '');
    //j
    IniFile.Free;

    //\
    StatusBar1.Panels.Items[0].Text := StrSearchValue;
    StatusBar2.Panels.Items[0].Text := StrSearchValue;

    //ݒ肠
    if FormMain.StrLoadFileName <> '' then
    begin
      //ݒ
      sStr1 := ExtractFilePath(FormMain.StrLoadFileName);
      //NA
      StrListFile.Clear;
      StrListFile.Sorted := FALSE;
      //wfBNĝׂĂ̎ނ̃t@C
      if FindFirst(sStr1 + '*.*', faAnyFile, File1) = 0 then
      begin
        //
        try
          //
          repeat
             //tH_JgfBNgefBNg͑ΏۊO
             if not((File1.Attr and faDirectory > 0)) and (File1.Name <> '.') and (File1.Name <> '..') then
             begin
               //gq𔻒
               if UpperCase(ExtractFileExt(File1.Name)) = UpperCase(ExtractFileExt(FormMain.StrLoadFileName)) then
               begin
                 StrListFile.Add(sStr1 + File1.Name);
               end;
             end;
           until (FindNext(File1) <> 0);
        finally
          FindClose(File1);
        end;
      end;

      //\[g
      StrListFile.CustomSort(CompareLogical2);

      //IvVݒ肷
      FormMain.SearchOptions := FormMain.SetOptions('', SEARCH_NEXT);


      //NA
      StrListFileLineCol.Clear;
      bError1 := FALSE;
      bError2 := FALSE;
      //
      for iRow1 := 0 to StrListFile.Count-1 do
      begin

        //Ǎ
        Memo5.Lines.LoadFromFile(StrListFile.Strings[iRow1]);
        //Ǎ
        StrListFileLoad.LoadFromFile(StrListFile.Strings[iRow1]);

        //Iɐ܂Ԃꍇ͏Ȃ
        if Memo5.Lines.Count <> StrListFileLoad.Count then
        begin
          //ݒ
          if BoolJapanese = TRUE then
          begin
            FormMain.StrMsg := 'Information : 1s̕1024ȏ̍ŝ' + #13#10 +
                               '̃t@C̏XLbv܂'      + #13#10 +
                               StrListFile.Strings[iRow1];
          end
          else
          begin
            FormMain.StrMsg := 'Information : Skip this file, because of charactor is more than 1024 in a line.' + #13#10 +
                               StrListFile.Strings[iRow1] + #13#10 +
                               '[OK]';
          end;
          ShowMessage(FormMain.StrMsg);

          //ݒ
          if BoolJapanese = TRUE then
          begin
            sStr3 := 'Information : ꊇp܂H';
          end
          else
          begin
            sStr3 := 'Information : Continue search all files ?' + #13#10 +
                     '[YES] / [NO]';
          end;
          wRet8 := MessageDlg(sStr3, mtInformation, [mbYes, mbNo ], 0);
          //s
          if wRet8 = mrYes then
          begin
            Continue;
          end
          else
          begin
            bError2 := TRUE;
            Break;
          end;
        end;

        //ݒ
        Info.Start := 0;
        FormMain.SearchOptions := FormMain.SetOptions('', SEARCH_NEXT);
        //NA
        StrListFileCol.Clear;
        //
        HtSearch.SearchText5(PWideChar(StrListFileLoad.Text), Info, StrSearchValue, FormMain.SearchOptions, StrListFileCol);


        //m
        IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
        //K\gp
        IniFile.WriteBool   ('Options',     'RegExp',      TRUE);
        //j
        IniFile.Free;

        //ݒ
        Info.Start := 0;
        FormMain.SearchOptions := FormMain.SetOptions('', SEARCH_NEXT);
        //NA
        StrListFileLine.Clear;
        //
        HtSearch.SearchText5(PWideChar(StrListFileLoad.Text), Info, '\r\n', FormMain.SearchOptions, StrListFileLine);

        //m
        IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
        //K\gp
        IniFile.WriteBool   ('Options',     'RegExp',      FALSE);
        //j
        IniFile.Free;


        //擾
        for iRow2 := 0 to StrListFileCol.Count-1 do
        begin
          //ݍs擾
          iPos1 := StrToInt(StrListFileCol.Strings[iRow2]);
          iLine1 := SendMessage(Memo5.Handle, EM_LINEFROMCHAR, iPos1, 0);
          //ݍs̊Jnʒu
          if iLine1 = 0 then
          begin
            iStart1 := 0;
          end
          else
          begin
            //#13#10̕Z
            iStart1 := StrToInt(StrListFileLine.Strings[iLine1-1]) + 2;
          end;

          //ǉ
          StrListFileLineCol.Add(StrListFile.Strings[iRow1] +
                                 '*' +
                                 '(' + IntToStr(iLine1 + 1) + ')' +
                                 '[' + IntToStr(iPos1 - iStart1 + 1)+ ']' +
                                 StrListFileLoad.Strings[iLine1]);

          //f
          if StrListFileLineCol.Count > FILE_FIND_LINE_MAX then
          begin
            bError1 := TRUE;
            Break;
          end;
        end;
      end;

      //ۑ
      StrListFileLineCol.SaveToFile(ExtractFilePath(ParamStr(0)) + FIND_FILE_ALL_TXT, TEncoding.Unicode);
      Memo1.Lines.LoadFromFile     (ExtractFilePath(ParamStr(0)) + FIND_FILE_ALL_TXT, TEncoding.Unicode);

      //XV
      MemoStatus(Sender);

      //m
      StrList2 := TStringList.Create;

      //ݒ
      for iRow1 := 0 to StrListFileLineCol.Count-1 do
      begin
        if iIndex1 = 0 then
        begin
          StrList2.Add(Format('%6d',  [iRow1+1]));
        end
        else
        begin
          StrList2.Add(Format('%.6d', [iRow1+1]));
        end;
      end;

      //t@C܂̓Xg[͍ɕ\\
      StrStream1 := TStringStream.Create(StrList2.Text);
      Memo9.Lines.LoadFromStream(StrStream1);
      StrStream1.Free;
      Memo9.SelStart := 0;
      //j
      StrList2.Free;

      //f
      if bError1 = TRUE then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Information : ʂ̍s ' + IntToStr(FILE_FIND_LINE_MAX) + ' s𒴂̂' + #13#10 +
                             'r܂ł̌ʂ\܂';
        end
        else
        begin
          FormMain.StrMsg := 'Information : The line number of search word is more than ' + IntToStr(FILE_FIND_LINE_MAX ) + '.' + #13#10 +
                             'Show results in the middle.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
      end;
      //f
      if bError2 = TRUE then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Information : r܂ł̌ʂ\܂';
        end
        else
        begin
          FormMain.StrMsg := 'Information : Show results in the middle.' + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
      end;
    end;
  end;
end;

procedure TFormFindAll.Memo1Click(Sender: TObject);
begin
  //XV
  MemoStatus(Sender);
end;

procedure TFormFindAll.Memo1DblClick(Sender: TObject);
var
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iLine1: Integer;
  iCol1: Integer;
  iStart1: Integer;
  iStart2: Integer;
  sStr1: String;
  sStr2: String;
begin
  if Memo1.Text = '' then
  begin
    Exit;
  end;

  if MenuSearchFileAll.Enabled = FALSE then
  begin
    Exit;
  end;

  //ݍs擾
  iLine1  := SendMessage(Memo1.Handle, EM_LINEFROMCHAR, UINT(-1), 0);
  //ݍs̐擪ʒu
  iStart1 := SendMessage(Memo1.Handle, EM_LINEINDEX,    UINT(-1), 0);

  //͈͔
  if iLine1 > Memo1.Lines.Count-1 then
  begin
    Exit;
  end;
  //擾
  //D:\DLPH_SRC\#PERSONAL\XE10-32-annsFMtext\test\000.csv*(1)[1]11,"22,22",33
  iPos3 := Pos('*', Memo1.Lines.Strings[iLine1]);
  sStr2 := Copy(Memo1.Lines.Strings[iLine1], iPos3+1, Length(Memo1.Lines.Strings[iLine1]));
  //e
  iPos1 := Pos('[', sStr2);
  iPos2 := Pos(']', sStr2);

  //Ke
  if (iPos1 > 0) and (iPos2 > 0)then
  begin
    //ʒu擾
    sStr1 := Copy(sStr2, iPos1 + 1, iPos2 - iPos1 - 1);
    iCol1 := StrToInt(sStr1);
    //J[\ʒuݒʒu
    iStart2 := iStart1 + iPos3 + iPos2 + iCol1 - 1;
    //J[\ړ
    Memo1.SelStart  := iStart2;
    Memo1.SelLength := Length(StrSearchValue);
  end;
  //XV
  MemoStatus(Sender);
end;

procedure TFormFindAll.Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Find ShowɕύX̂
  Info.Start  := Memo1.SelStart;
  Info.Length := Memo1.SelLength;

  //XV
  MemoStatus(Sender);
end;

procedure TFormFindAll.MemoStatus(Sender: TObject);
var
  iLine1: Integer;
  iSel1: Integer;
  iSel2: Integer;
begin
  // -1nƌ݂̃Lbgʒu̍sԍ(Ox[X)
  //@@  iLine1  := RichEdit1.Perform(EM_LINEFROMCHAR, -1, 0);
  iLine1  := Memo1.Perform(EM_LINEFROMCHAR, UINT(-1), 0);
  // -1nČ݂̃Lbgʒu̍s̐擪ʒu(Ox[X)
  //@@  iSel1   := RichEdit1.Perform(EM_LINEINDEX,    -1, 0);
  iSel1   := Memo1.Perform(EM_LINEINDEX,    UINT(-1), 0);
  //Lbgʒu(Ox[X)
  iSel2   := Memo1.SelStart;

  //\
  StatusBar1.Panels.Items[1].Text := Format('%d', [iLine1+1])          + 's,' +
                                     Format('%d', [iSel2-iSel1+1])     + '';
  StatusBar2.Panels.Items[1].Text := Format('%d', [iLine1+1])          + 's,' +
                                     Format('%d', [iSel2-iSel1+1])     + '';
  StatusBar1.Panels.Items[2].Text := Format('%d', [Memo1.Lines.Count]) + 's';
  StatusBar2.Panels.Items[2].Text := Format('%d', [Memo1.Lines.Count]) + 's';

end;

end.
