unit Jump;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, DecEdit, Vcl.ExtCtrls,
  IniFiles;

type
  TFormJump = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    DecEdit1: TDecEdit;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure DecEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private 錾 }
    BoolJapanese: Boolean;
    StrLanguageFileName: String;
  public
    { Public 錾 }
  end;

var
  FormJump: TFormJump;

implementation

uses
  Main;

{$R *.dfm}


//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormJump.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormJump.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormJump.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormJump.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ǂݍ
  DecEdit1.Text := IniFile.ReadString('Editor', 'Jump',  '1');
  //j
  IniFile.Free;
end;

procedure TFormJump.FormDestroy(Sender: TObject);
begin
  //;
end;

procedure TFormJump.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormJump.KeyPreview := TRUE;

  //tH[JX
  DecEdit1.SetFocus;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Jump.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormJump, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormJump, StrLanguageFileName, Sender);
  end;
end;

procedure TFormJump.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end;
end;

procedure TFormJump.DecEdit1KeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
  //Enter
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    //OK
    ButtonOkClick(Sender);
  end;
end;

procedure TFormJump.ButtonOkClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if Length(DecEdit1.Text) > 9 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : 9ȉݒ肵Ă';
    end
    else
    begin
      FormMain.StrMsg := 'Information : Word length set less than 9 characters.' + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
    Exit;
  end;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  IniFile.WriteString('Editor', 'Jump',  DecEdit1.Text);
  //j
  IniFile.Free;
  //
  ModalResult := mrOk;
end;

procedure TFormJump.ButtonCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

end.

