unit KeyBoard;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  IniFiles, CommCtrl, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls, MyUtility,
  System.UITypes;


const
  FORM_WIDTH_SET    = 900;
  FORM_HEIGHT_SET   = 460;

type
  TFormKeyBoard = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ButtonDiffToFile: TButton;
    ButtonButtonLoadFromFile: TButton;
    ButtonShowDiff: TButton;
    ButtonShowAll: TButton;
    ButtonClear: TButton;
    ButtonInitMemo: TButton;
    ButtonInitAnnsFM: TButton;
    Label1: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ListView1: TListView;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox3KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox4KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox5KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonDiffToFileClick(Sender: TObject);
    procedure ButtonButtonLoadFromFileClick(Sender: TObject);
    procedure ButtonShowDiffClick(Sender: TObject);
    procedure ButtonShowAllClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonInitMemoClick(Sender: TObject);
    procedure ButtonInitAnnsFMClick(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);

    procedure ChangePresentKey(Sender: TObject);
    procedure SetPresentKey(Sender: TObject);
    procedure SetCategory(Number: String; ComboBox: TcomboBox; Sender: TObject);
    procedure SetCommand(Sender: TObject);

    procedure ReadKeyMapFromFile(Sender: TObject);
    procedure SetKeyMapJpnEng(LanguageJpn: Boolean; StrListMap: TStringList; Sender: TObject);
    procedure SetThisCategory(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    StrListKeyMap: TStringList;
    BoolSaveToFile: Boolean;
    StrParentForm: String;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;
  public
    { Public 錾 }
  end;

var
  FormKeyBoard: TFormKeyBoard;

implementation

uses
  Main, KeyMap, FindAll;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormKeyBoard.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormKeyBoard.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormKeyBoard.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormKeyBoard.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormKeyBoard.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormKeyBoard', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormKeyBoard', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormKeyBoard', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormKeyBoard', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormKeyBoard', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  StrListKeyMap := TStringList.Create;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  StrParentForm := IniFile.ReadString('FormKeyBoard', 'Parent', PARENT_MAIN);
  //j
  IniFile.Free;

  //FormShow̑Oɂǂݍ
  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //ݒ
  if BoolJapanese = TRUE then
  begin
    ListView1.Columns.Add.Caption  := 'R}h';
    ListView1.Columns.Add.Caption  := '݂̃L[';
    ListView1.Columns.Add.Caption  := '@\';
    ListView1.Columns.Add.Caption  := '';
  end
  else
  begin
    ListView1.Columns.Add.Caption  := 'Command';
    ListView1.Columns.Add.Caption  := 'Current Key';
    ListView1.Columns.Add.Caption  := 'Function';
    ListView1.Columns.Add.Caption  := '';
  end;
    ListView1.Columns[0].Width := 425;
    ListView1.Columns[1].Width := 295;
    ListView1.Columns[2].Width := 110;
    ListView1.Columns[3].Width :=  10;
    ListView1.Items.Clear;
    ListView1.ViewStyle := vsReport;
    ListView1.RowSelect := TRUE;
    ListView1.MultiSelect := FALSE;
    ListView1.ReadOnly := TRUE;

  //ݒ
  BoolSaveToFile := FALSE;
end;

procedure TFormKeyBoard.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormKeyBoard', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormKeyBoard', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormKeyBoard', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormKeyBoard', 'Left',   FormKeyBoard.Left);
    IniFile.WriteInteger('FormKeyBoard', 'Top',    FormKeyBoard.Top);
    IniFile.WriteInteger('FormKeyBoard', 'Width',  FormKeyBoard.Width);
    IniFile.WriteInteger('FormKeyBoard', 'Height', FormKeyBoard.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListKeyMap.Free;
end;

procedure TFormKeyBoard.FormResize(Sender: TObject);
begin
  ListView1.Width  := FormKeyBoard.ClientWidth  -  45;
  ListView1.Height := FormKeyBoard.ClientHeight - 145;
  ListView1.Columns[0].Width := FormkeyBoard.ClientWidth -45 - 200 - 110 -10;
  ListView1.Columns[1].Width := 200;
  ListView1.Columns[2].Width := 110;
  ListView1.Columns[3].Width :=  10;
end;

procedure TFormKeyBoard.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormKeyBoard.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormKeyBoard.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormKeyBoard.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormKeyBoard.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormKeyBoard.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'KeyBoard.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormKeyBoard, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormKeyBoard, StrLanguageFileName, Sender);
  end;

  //ݒ
  if BoolJapanese = TRUE  then
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);
  end
  else
  begin
    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);
  end;

  //ݒ
  ComboBox1.SetFocus;
end;

procedure TFormKeyBoard.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //{
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_J)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := TRUE;
    //{
    FormMain.SetJapanese(FormKeyBoard, StrLanguageFileName, Sender);

    //{
    ListView1.Columns[0].Caption  := 'R}h';
    ListView1.Columns[1].Caption  := '݂̃L[';
    ListView1.Columns[2].Caption  := '@\';
    ListView1.Columns[3].Caption  := '';

    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(TRUE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);
  end
  //p
  else if ((Shift = [ssShift, ssCtrl]) and (key = VK_E)) and (FormMain.BoolDeveloper = TRUE) then
  begin
    //ݒ
    BoolJapanese := FALSE;
    //p
    FormMain.SetEnglish(FormKeyBoard, StrLanguageFileName, Sender);

    //p
    ListView1.Columns[0].Caption  := 'Command';
    ListView1.Columns[1].Caption  := 'Current Key';
    ListView1.Columns[2].Caption  := 'Function';
    ListView1.Columns[3].Caption  := '';

    //Ǎ
    ReadKeyMapFromFile(Sender);
    //
    SetKeyMapJpnEng(FALSE, StrListKeyMap, Sender);
    //JeSݒ
    SetThisCategory(Sender);
    //Xgɐݒ
    SetCommand(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormKeyBoard.ButtonOKClick(Sender: TObject);
var
  sStr3: String;
begin
  //ݒ
  if StrParentForm = PARENT_MAIN then
  begin
    //ۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
    StrListKeymap.SaveToFile(sStr3, TEncoding.Unicode);
    //
    ModalResult := mrOK;
  end;
  if StrParentForm = PARENT_FIND_ALL then
  begin
    //ۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYMAP_FINDALL_LIST;
    StrListKeymap.SaveToFile(sStr3, TEncoding.Unicode);
    //
    ModalResult := mrOK;
  end;

end;

procedure TFormKeyBoard.ButtonCancelClick(Sender: TObject);
begin
  if BoolSaveToFile = TRUE then
  begin
    //I
    ModalResult := mrOk;
  end
  else
  begin
    //I
    ModalResult := mrCancel;
  end;
end;

procedure TFormKeyBoard.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox4KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox5KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox1Change(Sender: TObject);
begin
  //R}hݒ
  SetCommand(Sender);
end;

procedure TFormKeyBoard.ComboBox2Change(Sender: TObject);
begin
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyBoard.ComboBox3Change(Sender: TObject);
begin
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyBoard.ComboBox4Change(Sender: TObject);
begin
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyBoard.ComboBox5Change(Sender: TObject);
begin
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyBoard.SetPresentKey(Sender: TObject);
var
 sStr1: String;
 sStr2: String;
 sStr3: String;
 sStr4: String;
 sStr5: String;
 sStr6: String;
 iPos2: Integer;
 iPos3: Integer;
 iPos4: Integer;
 iRow1: Integer;
begin
  //
  if ListView1.ItemIndex = -1 then
  begin
    ListView1.ItemIndex := 0;
  end;

  //擾
  sStr1 := ListView1.Items[ListView1.ItemIndex].SubItems[0];
  iPos2 := Pos('Shift', sStr1);
  iPos3 := Pos('Ctrl',  sStr1);
  iPos4 := Pos('Alt',   sStr1);
  sStr2 := StringReplace(sStr1, 'Shift', '', [rfReplaceAll]);
  sStr3 := StringReplace(sStr2, 'Ctrl',  '', [rfReplaceAll]);
  sStr4 := StringReplace(sStr3, 'Alt',   '', [rfReplaceAll]);
  sStr5 := StringReplace(sStr4, '+',     '', [rfReplaceAll]);
  sStr6 := Trim(sStr5);

  //f
  if iPos2 = 0 then
  begin
    ComboBox2.ItemIndex := 0;
  end
  else
  begin
    ComboBox2.ItemIndex := 1;
  end;

  if iPos3 = 0 then
  begin
    ComboBox3.ItemIndex := 0;
  end
  else
  begin
    ComboBox3.ItemIndex := 1;
  end;

  if iPos4 = 0 then
  begin
    ComboBox4.ItemIndex := 0;
  end
  else
  begin
    ComboBox4.ItemIndex := 1;
  end;

  for iRow1 := 0 to ComboBox5.Items.Count-1 do
  begin
    if Trim(ComboBox5.Items.Strings[iRow1] )= sStr6 then
    begin
      ComboBox5.ItemIndex := iRow1;
      Break;
    end;
  end;
end;

procedure TFormKeyBoard.ChangePresentKey(Sender: TObject);
var
  sStr1: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  StrList1: TStringList;
begin
  //L[󔒂
  if Trim(ComboBox5.Text) = '' then
  begin
    //L[ȊOݒ肳Ă
    sStr1 := Trim(ComboBox2.Text) + Trim(ComboBox3.Text) + Trim(ComboBox4.Text);
    if (sStr1 <> '') then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : Shift,Ctrl,Alt̃L[ݒ肳Ă܂AL[ݒ肳Ă܂';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Shift,Ctrl,Alt is set, but Key is empty.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //擾
  if Trim(ComboBox2.Text) <> '' then
  begin
    sStr1 := Trim(ComboBox2.Text);
  end;

  if Trim(ComboBox3.Text) <> '' then
  begin
    if sStr1 = '' then
    begin
      sStr1 := sStr1 + Trim(ComboBox3.Text);
    end
    else
    begin
      sStr1 := sStr1  + '+' + Trim(ComboBox3.Text);
    end;
  end;

  if Trim(ComboBox4.Text) <> '' then
  begin
    if sStr1 = '' then
    begin
      sStr1 := sStr1 + Trim(ComboBox4.Text);
    end
    else
    begin
      sStr1 := sStr1  + '+' + Trim(ComboBox4.Text);
    end;
  end;

  if Trim(ComboBox5.Text) <> '' then
  begin
    if sStr1 = '' then
    begin
      sStr1 := sStr1 + Trim(ComboBox5.Text);
    end
    else
    begin
      sStr1 := sStr1  + '+' + Trim(ComboBox5.Text);
    end;
  end;

  //
  if ListView1.ItemIndex = -1 then
  begin
    ListView1.ItemIndex := 0;
  end;

  //
  if sStr1 = '' then
  begin
  end
  else
  begin
    if sStr1 = ListView1.Items[ListView1.ItemIndex].SubItems[0] then
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : ̐ݒł';
      end
      else
      begin
        FormMain.StrMsg := 'Information : Same setting is exist.' + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
      Exit;
    end;
  end;

  //m
  StrList1 := TStringList.Create;

    //
    for iRow1 := 0 to StrListKeyMap.Count-1 do
    begin
      //擾
      sStr11 := StrListKeyMap.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001

      StrList1.Add(sStr11);
    end;


  //
  if sStr1 <> '' then
  begin
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //擾
      sStr11 := StrList1.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
      if sStr16 = sStr1 then
      begin
        //ݒ
        if BoolJapanese = TRUE then
        begin
          FormMain.StrMsg := 'Information : [' + sStr12  + '] ŊɎgpς݂ł̂Őݒł܂' ;
        end
        else
        begin
          FormMain.StrMsg := 'Information : This setting can not be set because of [' + sStr12  + '] is already exist.'  + #13#10 +
                             '[OK]';
        end;
        ShowMessage(FormMain.StrMsg);
        Exit;
      end;
    end;
  end;

  //f
  if ListView1.Items.Count > 0 then
  begin
    //ݒ
    ListView1.Items.Item[ListView1.ItemIndex].SubItems[0] := sStr1;
    //
    for iRow1 := 0 to StrListKeyMap.Count-1 do
    begin
      //擾
      sStr11 := StrListKeyMap.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
      if sStr17 =  ListView1.Items.Item[ListView1.ItemIndex].SubItems[1] then
      begin
        StrListKeyMap.Strings[iRow1] :=  sStr12 + #9 + sStr14 + #9 + sStr1 + #9 + sStr17;
        Break;
      end;
    end;
  end;

  //j
  StrList1.Free;
end;

procedure TFormKeyBoard.SetCategory(Number: String; ComboBox: TcomboBox; Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
begin
  //ԍ
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      ComboBox.Items.Add(sStr12);
      Break;
    end;
  end;
end;

procedure TFormKeyBoard.SetCommand(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //XV
  ListView1.Items.BeginUpdate;
  //NA
  ListView1.Items.Clear;
  //ԍ
  iRow2 := 0;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr12 = ComboBox1.Text then
    begin
      nItem := ListView1.Items.Add;
      nItem.Caption := sStr14;
      ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
      ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
      iRow2 := iRow2+1;
    end;
  end;
  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;
  //XV
  ListView1.Items.EndUpdate;
  //ݒ
  ListView1Click(Sender);
end;


procedure TFormKeyBoard.ButtonDiffToFileClick(Sender: TObject);
var
  sStr2: String;
  sStr3: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
  sStr26: String;
  sStr27: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos21: Integer;
  iPos22: Integer;
  iPos23: Integer;
  StrList1: TStringList;
  wRet1: Word;
begin
  //mF
  if BoolJapanese = TRUE then
  begin
    sStr2 := 'Information : ύXt@Cɏ㏑ŕۑ܂H';
  end
  else
  begin
    sStr2 := 'Information : Overwrite change items to file ?' + #13#10 +
             '[YES] / [NO]';
  end;
  wRet1 := MessageDlg(sStr2, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet1 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;

  //ݒ
  if StrParentForm = PARENT_MAIN then
  begin

    //ԍ̃V[gJbgݒ
    for iRow1 := 0 to StrListKeyMap.Count-1 do
    begin
      //擾
      sStr11 := StrListKeyMap.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001

      //ԍ
      for iRow2 := 0 to FormMain.StrListKeyMapOriginal.Count-1 do
      begin
        //擾
        sStr21 := FormMain.StrListKeyMapOriginal.Strings[iRow2];
        iPos21 := Pos(#9, sStr21);
        sStr22 := Copy(sStr21, 1,        iPos21-1);      //t@C
        sStr23 := Copy(sStr21, iPos21+1, Length(sStr21));//ȍ~̕
        iPos22 := Pos(#9, sStr23);
        sStr24 := Copy(sStr23, 1,        iPos22-1);      //VK쐬
        sStr25 := Copy(sStr23, iPos22+1, Length(sStr23));//ȍ~̕
        iPos23 := Pos(#9, sStr25);
        sStr26 := Copy(sStr25, 1,        iPos23-1);      //Ctrl+O
        sStr27 := Copy(sStr25, iPos23+1, Length(sStr25));//1001
        //ԍ
        if sStr17 = sStr27 then
        begin
          if sStr16 <> sStr26 then
          begin
            StrList1.Add(sStr11);
            Break;
          end
        end;
      end;
    end;
    //ۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYDIFF_LIST;
    StrList1.SaveToFile(sStr3, TEncoding.Unicode);
  end;


  if StrParentForm = PARENT_FIND_ALL then
  begin
    //ԍ̃V[gJbgݒ
    for iRow1 := 0 to StrListKeyMap.Count-1 do
    begin
      //擾
      sStr11 := StrListKeyMap.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001

      //ԍ
      for iRow2 := 0 to FormFindAll.StrListKeyMapOriginal.Count-1 do
      begin
        //擾
        sStr21 := FormFindAll.StrListKeyMapOriginal.Strings[iRow2];
        iPos21 := Pos(#9, sStr21);
        sStr22 := Copy(sStr21, 1,        iPos21-1);      //t@C
        sStr23 := Copy(sStr21, iPos21+1, Length(sStr21));//ȍ~̕
        iPos22 := Pos(#9, sStr23);
        sStr24 := Copy(sStr23, 1,        iPos22-1);      //VK쐬
        sStr25 := Copy(sStr23, iPos22+1, Length(sStr23));//ȍ~̕
        iPos23 := Pos(#9, sStr25);
        sStr26 := Copy(sStr25, 1,        iPos23-1);      //Ctrl+O
        sStr27 := Copy(sStr25, iPos23+1, Length(sStr25));//1001
        //ԍ
        if sStr17 = sStr27 then
        begin
          if sStr16 <> sStr26 then
          begin
            StrList1.Add(sStr11);
            Break;
          end
        end;
      end;
    end;
    //ۑ
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYDIFF_FINDALL_LIST;
    StrList1.SaveToFile(sStr3, TEncoding.Unicode);
  end;

  //j
  StrList1.Free;

  //
  if StrParentForm = PARENT_MAIN then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@Cۑ܂' + #13#10 +
                           ExtractFileName(sStr3);
    end
    else
    begin
      FormMain.StrMsg := 'Information : File saved.'  + #13#10 +
                         KEYDIFF_LIST + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
  if StrParentForm = PARENT_FIND_ALL then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      FormMain.StrMsg := 'Information : t@Cۑ܂' + #13#10 +
                           ExtractFileName(sStr3);
    end
    else
    begin
      FormMain.StrMsg := 'Information : File saved.'  + #13#10 +
                         KEYDIFF_FINDALL_LIST + #13#10 +
                         '[OK]';
    end;
    ShowMessage(FormMain.StrMsg);
  end;
end;

procedure TFormKeyBoard.ButtonInitAnnsFMClick(Sender: TObject);
var
  sStr1: String;
  sStr3: String;
  wRet3: Word;
begin
  //mF
  if BoolJapanese = TRUE then
  begin
    sStr3 := 'Information : ݒĕۑ܂H';
  end
  else
  begin
    sStr3 := 'Information : Initialize and save to file ?' + #13#10 +
             '[YES] / [NO]';
  end;
  wRet3 := MessageDlg(sStr3, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet3 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //ݒ
  BoolSaveToFile := TRUE;

  //ݒ
  if StrParentForm = PARENT_MAIN then
  begin
    //ۑ
    FormMain.InitKeyMap(0, Sender);
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
    FormMain.StrListKeyMapOriginal.SaveToFile(sStr1, TEncoding.Unicode);
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
  end;
  if StrParentForm = PARENT_FIND_ALL then
  begin
    //ۑ
    FormFindAll.InitKeyMap(0, Sender);
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FINDALL_LIST;
    FormFindAll.StrListKeyMapOriginal.SaveToFile(sStr1, TEncoding.Unicode);
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
  end;


  //ݒ
  ComboBox1.ItemIndex := 0;
  //f
  SetCommand(Sender);
  //ݒ
  ComboBox1.SetFocus;
end;

procedure TFormKeyBoard.ButtonInitMemoClick(Sender: TObject);
var
  sStr1: String;
  sStr3: String;
  wRet3: Word;
begin
  //mF
  if BoolJapanese = TRUE then
  begin
    sStr3 := 'Information : ݒĕۑ܂H';
  end
  else
  begin
    sStr3 := 'Information : Initialize and save to file ?' + #13#10 +
             '[YES] / [NO]';
  end;
  wRet3 := MessageDlg(sStr3, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet3 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //ݒ
  BoolSaveToFile := TRUE;

  //ݒ
  if StrParentForm = PARENT_MAIN then
  begin
    //ۑ
    FormMain.InitKeyMap(1, Sender);
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
    FormMain.StrListKeyMapOriginal.SaveToFile(sStr1, TEncoding.Unicode);
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
    //IWiĐݒ
    FormMain.InitKeyMap(0, Sender);
  end;
  if StrParentForm = PARENT_FIND_ALL then
  begin
    //ۑ
    FormFindAll.InitKeyMap(1, Sender);
    sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_FINDALL_LIST;
    FormFindAll.StrListKeyMapOriginal.SaveToFile(sStr1, TEncoding.Unicode);
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
    //IWiĐݒ
    FormFindAll.InitKeyMap(0, Sender);
  end;

  //ݒ
  ComboBox1.ItemIndex := 0;
  //f
  SetCommand(Sender);
  //ݒ
  ComboBox1.SetFocus;
end;

procedure TFormKeyBoard.ButtonButtonLoadFromFileClick(Sender: TObject);
var
  StrList1: TStringList;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
  sStr26: String;
  sStr27: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos21: Integer;
  iPos22: Integer;
  iPos23: Integer;
  wRet1: Word;
begin
  //mF
  if BoolJapanese = TRUE then
  begin
    sStr2 := 'Information : ύX𔽉fAt@Cɕۑ܂H';
  end
  else
  begin
    sStr2 := 'Information : Replace different items, and save to file ?' + #13#10 +
             '[YES] / [NO]';
  end;
  wRet1 := MessageDlg(sStr2, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet1 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;

  //ݒ
  if StrParentForm = PARENT_MAIN then
  begin
    //t@CǍ
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYDIFF_LIST;
    if FileExists(sStr3) = TRUE then
    begin
       //Ǎ
      StrList1.LoadFromFile(sStr3, TEncoding.Unicode);

      //
      for iRow1 := 0 to StrList1.Count-1 do
      begin
        //擾
        sStr11 := StrList1.Strings[iRow1];
        iPos11 := Pos(#9, sStr11);
        sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
        sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
        iPos12 := Pos(#9, sStr13);
        sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
        sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
        iPos13 := Pos(#9, sStr15);
        sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
        sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001

        //
        for iRow2 := 0 to StrListKeyMap.Count-1 do
        begin
          //擾
          sStr21 := StrListKeyMap.Strings[iRow2];
          iPos21 := Pos(#9, sStr21);
          sStr22 := Copy(sStr21, 1,        iPos21-1);      //t@C
          sStr23 := Copy(sStr21, iPos21+1, Length(sStr21));//ȍ~̕
          iPos22 := Pos(#9, sStr23);
          sStr24 := Copy(sStr23, 1,        iPos22-1);      //VK쐬
          sStr25 := Copy(sStr23, iPos22+1, Length(sStr23));//ȍ~̕
          iPos23 := Pos(#9, sStr25);
          sStr26 := Copy(sStr25, 1,        iPos23-1);      //Ctrl+O
          sStr27 := Copy(sStr25, iPos23+1, Length(sStr25));//1001
          if sStr17 = sStr27 then
          begin
            StrListKeyMap.Strings[iRow2] :=  sStr22 + #9 + sStr24 + #9 + sStr16 + #9 + sStr27;
            Break;
          end;
        end;
      end;
      //ݒ
      BoolSaveToFile := TRUE;

      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : t@Cǂݍݔf܂' + #13#10 +
                           KEYDIFF_LIST;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Read file and Update items.'  + #13#10 +
                           KEYDIFF_LIST + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : t@C܂' + #13#10 +
                           KEYDIFF_LIST;
      end
      else
      begin
        FormMain.StrMsg := 'Information : File is not exist.'  + #13#10 +
                           KEYDIFF_LIST + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
    //ۑ
    sStr4 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
    StrListKeyMap.SaveToFile(sStr4, TEncoding.Unicode);
  end;

  if StrParentForm = PARENT_FIND_ALL then
  begin
    //t@CǍ
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYDIFF_FINDALL_LIST;
    if FileExists(sStr3) = TRUE then
    begin
       //Ǎ
      StrList1.LoadFromFile(sStr3, TEncoding.Unicode);

      //
      for iRow1 := 0 to StrList1.Count-1 do
      begin
        //擾
        sStr11 := StrList1.Strings[iRow1];
        iPos11 := Pos(#9, sStr11);
        sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
        sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
        iPos12 := Pos(#9, sStr13);
        sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
        sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
        iPos13 := Pos(#9, sStr15);
        sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
        sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001

        //
        for iRow2 := 0 to StrListKeyMap.Count-1 do
        begin
          //擾
          sStr21 := StrListKeyMap.Strings[iRow2];
          iPos21 := Pos(#9, sStr21);
          sStr22 := Copy(sStr21, 1,        iPos21-1);      //t@C
          sStr23 := Copy(sStr21, iPos21+1, Length(sStr21));//ȍ~̕
          iPos22 := Pos(#9, sStr23);
          sStr24 := Copy(sStr23, 1,        iPos22-1);      //VK쐬
          sStr25 := Copy(sStr23, iPos22+1, Length(sStr23));//ȍ~̕
          iPos23 := Pos(#9, sStr25);
          sStr26 := Copy(sStr25, 1,        iPos23-1);      //Ctrl+O
          sStr27 := Copy(sStr25, iPos23+1, Length(sStr25));//1001
          if sStr17 = sStr27 then
          begin
            StrListKeyMap.Strings[iRow2] :=  sStr22 + #9 + sStr24 + #9 + sStr16 + #9 + sStr27;
            Break;
           end;
        end;
      end;
      //ݒ
      BoolSaveToFile := TRUE;

      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : t@Cǂݍݔf܂' + #13#10 +
                           KEYDIFF_FINDALL_LIST;
      end
      else
      begin
        FormMain.StrMsg := 'Information : Read file and Update items.'  + #13#10 +
                           KEYDIFF_FINDALL_LIST + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        FormMain.StrMsg := 'Information : t@C܂' + #13#10 +
                           KEYDIFF_FINDALL_LIST;
      end
      else
      begin
        FormMain.StrMsg := 'Information : File is not exist.'  + #13#10 +
                           KEYDIFF_FINDALL_LIST + #13#10 +
                           '[OK]';
      end;
      ShowMessage(FormMain.StrMsg);
    end;
    //ۑ
    sStr4 := ExtractFilePath(ParamStr(0)) + KEYMAP_FINDALL_LIST;
    StrListKeyMap.SaveToFile(sStr4, TEncoding.Unicode);
  end;

  //j
  StrList1.Free;

  //f
  ComboBox1Change(Sender);

end;

procedure TFormKeyBoard.ButtonShowDiffClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  IniFile.WriteBool('ShowKeyMapItem', 'All',  FALSE);
  //j
  IniFile.Free;

  //
  FormKeyMap := TFormKeyMap.Create(Application);
  try
    FormKeyMap.ShowModal;
  finally
    //j
    FormKeyMap.Free;
  end;
end;

procedure TFormKeyBoard.ButtonShowAllClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  IniFile.WriteBool('ShowKeyMapItem', 'All',  TRUE);
  //j
  IniFile.Free;

  //
  FormKeyMap := TFormKeyMap.Create(Application);
  try
    FormKeyMap.ShowModal;
  finally
    //j
    FormKeyMap.Free;
  end;
end;

procedure TFormKeyBoard.ListView1Click(Sender: TObject);
begin
  //ݒ
  SetPresentKey(Sender);
end;

procedure TFormKeyBoard.ListView1AdvancedCustomDrawItem(
  Sender: TCustomListView; Item: TListItem; State: TCustomDrawState;
  Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  AIndex: Integer;
  ARect: TRect;
  dwFormat: DWORD;
  iRow1: Integer;
  StrItem: String;
begin
  //tH[JX
  if ListView1.Focused = FALSE then
  begin
    //I
    if Item.Selected then
    begin
      //ݒ
      AIndex := Item.Index;
      //sRecẗ擾Dȉł
      //ListView_GetItemRect(ListView1.Handle, AIndex, ARect, LVIR_BOUNDS);
      ARect := Item.DisplayRect(drBounds);
//      OffsetRect(ARect, 3, 0);
      OffsetRect(ARect, 0, 0);
      //̗̈hׂ
      ListView1.Canvas.Brush.Color := clAqua;
      ListView1.Canvas.FillRect(ARect);
      ListView1.Canvas.Font.Color := clWindowText;

      //ݒ
      SetBkMode(ListView1.Canvas.Handle, TRANSPARENT);
      dwFormat := DT_SINGLELINE or DT_VCENTER;
      //Ō܂ŕ`
      for iRow1 := 0 to ListView1.Columns.Count-2 do
      begin
        //`ʒuݒ
        case ListView1.Column[iRow1].Alignment of
          taRightJustify: dwFormat := dwFormat or DT_RIGHT;
          taCenter      : dwFormat := dwFormat or DT_CENTER;
        else
          dwFormat := dwFormat or DT_LEFT;
        end;
        //Caption̂̏ꍇ
        if iRow1 = 0 then
        begin
          //͈͂擾
          ARect   := Item.DisplayRect(drLabel);
          //
          ARect   := Rect(ARect.Left + 3, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.Caption;
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end
        //CaptionȊO
        else
        begin
          //CommCtrlKvBdvłB
          //͈͂擾
          ListView_GetSubItemRect(ListView1.Handle, AIndex, iRow1, LVIR_LABEL, @ARect);
          //
          ARect   := Rect(ARect.Left + 6, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.SubItems[iRow1-1];
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end;
      end;
      //{̕`͎sȂ悤ɂȂƁAꕔ̍sŃtHgȂĂ܂
      DefaultDraw := False;
    end;
  end;

end;

procedure TFormKeyBoard.ListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ݒ
  SetPresentKey(Sender);
end;

procedure TFormKeyBoard.ButtonClearClick(Sender: TObject);
begin
  ComboBox2.ItemIndex := 0;
  ComboBox3.ItemIndex := 0;
  ComboBox4.ItemIndex := 0;
  ComboBox5.ItemIndex := 0;
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyboard.ReadKeyMapFromFile(Sender: TObject);
var
  sStr3: String;
begin
  if StrParentForm = PARENT_MAIN then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
  end;

  if StrParentForm = PARENT_FIND_ALL then
  begin
    sStr3 := ExtractFilePath(ParamStr(0)) + KEYMAP_FINDALL_LIST;;
  end;

  if FileExists(sStr3) = TRUE then
  begin
    StrListKeyMap.LoadFromFile(sStr3, TEncoding.Unicode);
  end;

end;

procedure TFormKeyboard.SetKeyMapJpnEng(LanguageJpn: Boolean; StrListMap: TStringList; Sender: TObject);
var
  sStr3: String;
  sStr4: String;
  iRow1: Integer;
  iRow2: Integer;
  CsvList1: TStringList;
  CsvList2: TStringList;
  StrList1: TStringList;
begin
  CsvList1 := TStringList.Create;
  CsvList2 := TStringList.Create;
  StrList1 := TStringList.Create;

  if StrParentForm = PARENT_MAIN then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Main.txt';
  end;

  if StrParentForm = PARENT_FIND_ALL  then
  begin
      //ݒ
      sStr3 := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
               ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'FindAll.txt';
  end;

  //t@Cǂݍ
  if FileExists(sStr3) = TRUE then
  begin
    //t@Cǂݍ
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);
    //
    for iRow1 := 0 to StrListMap.Count-1 do
    begin
      //WJ
      CsvList1.Clear;
      StringToCsvList(StrListMap.Strings[iRow1], CsvList1);
      //
      for iRow2 := 0 to StrList1.Count-1 do
      begin
        //WJ
        CsvList2.Clear;
        StringToCsvList(StrList1.Strings[iRow2], CsvList2);
        //v
        if CsvList1[3]  = CsvList2[0] then
        begin
          if      (CsvList1[0] = SHORTCUT_ITEM_KEY) or (CsvList1[0] = SHORTCUT_ITEM_KEY_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_KEY;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_KEY_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_SHIFT) or (CsvList1[0] = SHORTCUT_ITEM_SHIFT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SHIFT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SHIFT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_CTRL) or (CsvList1[0] = SHORTCUT_ITEM_CTRL_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_CTRL;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_CTRL_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_OTHERS) or (CsvList1[0] = SHORTCUT_ITEM_OTHERS_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_OTHERS;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_OTHERS_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_FILE) or (CsvList1[0] = SHORTCUT_ITEM_FILE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_FILE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_FILE_ENG;
            end;
          end

          else if (CsvList1[0] = SHORTCUT_ITEM_SEARCH) or (CsvList1[0] = SHORTCUT_ITEM_SEARCH_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SEARCH;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SEARCH_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_EDIT) or (CsvList1[0] = SHORTCUT_ITEM_EDIT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_EDIT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_EDIT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_CODE) or (CsvList1[0] = SHORTCUT_ITEM_CODE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_CODE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_CODE_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_VIEW) or (CsvList1[0] = SHORTCUT_ITEM_VIEW_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_VIEW;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_VIEW_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_BINARY) or (CsvList1[0] = SHORTCUT_ITEM_BINARY_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_BINARY;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_BINARY_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_COMMON) or (CsvList1[0] = SHORTCUT_ITEM_COMMON_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_COMMON;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_COMMON_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_EXPAND) or (CsvList1[0] = SHORTCUT_ITEM_EXPAND_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_EXPAND;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_EXPAND_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_HELP) or (CsvList1[0] = SHORTCUT_ITEM_HELP_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_HELP;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_HELP_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_TEXT) or (CsvList1[0] = SHORTCUT_ITEM_TEXT_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_TEXT;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_TEXT_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_MOVE) or (CsvList1[0] = SHORTCUT_ITEM_MOVE_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_MOVE;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_MOVE_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_SETTING) or (CsvList1[0] = SHORTCUT_ITEM_SETTING_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_SETTING;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_SETTING_ENG;
            end;
          end
          else if (CsvList1[0] = SHORTCUT_ITEM_JPN_ENG) or (CsvList1[0] = SHORTCUT_ITEM_JPN_ENG_ENG) then
          begin
            if LanguageJpn = TRUE then
            begin
              sStr4 := SHORTCUT_ITEM_JPN_ENG;
            end
            else
            begin
              sStr4 := SHORTCUT_ITEM_JPN_ENG_ENG;
            end;
          end

          else
          begin
            sStr4 := CsvList1[0];
          end;

          //Đݒ
          if LanguageJpn = TRUE then
          begin
            StrListMap.Strings[iRow1] := sStr4 + #09 + CsvList2[4] + #09  + CsvList1[2] + #09  + CsvList1[3];
          end
          else
          begin
            StrListMap.Strings[iRow1] := sStr4 + #09 + CsvList2[5] + #09  + CsvList1[2] + #09  + CsvList1[3];
          end;
          //
          Break;
        end;
      end;
    end;
  end;

  CsvList1.Free;
  CsvList2.Free;
  StrList1.Free;
end;

procedure TFormKeyboard.SetThisCategory(Sender: TObject);
begin
  //R}h̍ڂݒ
  if StrListKeyMap.Count > 0 then
  begin
    //NA
    ComboBox1.Items.Clear;

    if StrParentForm = PARENT_MAIN then
    begin
      //
      SetCategory('1001', ComboBox1, Sender);
      SetCategory('1101', ComboBox1, Sender);
      SetCategory('1201', ComboBox1, Sender);
      SetCategory('1301', ComboBox1, Sender);
      SetCategory('1401', ComboBox1, Sender);
      SetCategory('1501', ComboBox1, Sender);
      SetCategory('1601', ComboBox1, Sender);
      SetCategory('1701', ComboBox1, Sender);
      SetCategory('1801', ComboBox1, Sender);
      SetCategory('1901', ComboBox1, Sender);
      SetCategory('1951', ComboBox1, Sender);
    end;

    if StrParentForm = PARENT_FIND_ALL  then
    begin
      //
      SetCategory('1001', ComboBox1, Sender);
      SetCategory('1101', ComboBox1, Sender);
      SetCategory('1201', ComboBox1, Sender);
      SetCategory('1301', ComboBox1, Sender);
      SetCategory('1401', ComboBox1, Sender);
      SetCategory('1501', ComboBox1, Sender);
    end;
    //ݒ
    ComboBox1.ItemIndex := 0;
  end;
end;

end.

