unit KigouSetting;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, DecEdit, Vcl.ExtCtrls,
  IniFiles;

type
  TFormKigouSetting = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    DecEdit1: TDecEdit;
    DecEdit2: TDecEdit;
    DecEdit3: TDecEdit;
    DecEdit4: TDecEdit;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
  private
    { Private 錾 }
    BoolJapanese: Boolean;
    StrLanguageFileName: String;
  public
    { Public 錾 }
  end;

var
  FormKigouSetting: TFormKigouSetting;

implementation

{$R *.dfm}

uses Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormKigouSetting.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormKigouSetting.FormClose(Sender: TObject; var Action: TCloseAction);
begin
;
end;

procedure TFormKigouSetting.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormKigouSetting.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  if FormMain.MenuSameAsAnnsView.Checked = TRUE then
  begin
    DecEdit1.Text := IntToStr(IniFile.ReadInteger('annsView', 'ShiftRet',  15));
    DecEdit2.Text := IntToStr(IniFile.ReadInteger('annsView', 'ShiftEof',  12));
    DecEdit3.Text := IntToStr(IniFile.ReadInteger('annsView', 'ShiftTab',   8));
    DecEdit4.Text := IntToStr(IniFile.ReadInteger('annsView', 'ShiftDbcs', 13));
  end
  else
  begin
    DecEdit1.Text := IntToStr(IniFile.ReadInteger('Editor', 'ShiftRet',  15));
    DecEdit2.Text := IntToStr(IniFile.ReadInteger('Editor', 'ShiftEof',  12));
    DecEdit3.Text := IntToStr(IniFile.ReadInteger('Editor', 'ShiftTab',   8));
    DecEdit4.Text := IntToStr(IniFile.ReadInteger('Editor', 'ShiftDbcs', 13));
  end;
  //j
  IniFile.Free;
end;

procedure TFormKigouSetting.FormDestroy(Sender: TObject);
begin
;
end;

procedure TFormKigouSetting.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end;
end;

procedure TFormKigouSetting.FormResize(Sender: TObject);
begin
;
end;

procedure TFormKigouSetting.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormKigouSetting.KeyPreview := TRUE;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'KigouSetting.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormKigouSetting, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormKigouSetting, StrLanguageFileName, Sender);
  end;
end;

procedure TFormKigouSetting.ButtonOkClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  if FormMain.MenuSameAsAnnsView.Checked = TRUE then
  begin
    IniFile.WriteInteger('annsView', 'ShiftRet',  StrToInt(DecEdit1.Text));
    IniFile.WriteInteger('annsView', 'ShiftEof',  StrToInt(DecEdit2.Text));
    IniFile.WriteInteger('annsView', 'ShiftTab',  StrToInt(DecEdit3.Text));
    IniFile.WriteInteger('annsView', 'ShiftDbcs', StrToInt(DecEdit4.Text));
  end
  else
  begin
    IniFile.WriteInteger('Editor', 'ShiftRet',  StrToInt(DecEdit1.Text));
    IniFile.WriteInteger('Editor', 'ShiftEof',  StrToInt(DecEdit2.Text));
    IniFile.WriteInteger('Editor', 'ShiftTab',  StrToInt(DecEdit3.Text));
    IniFile.WriteInteger('Editor', 'ShiftDbcs', StrToInt(DecEdit4.Text));
  end;
  //j
  IniFile.Free;

  //I
  ModalResult := mrOK;
end;

procedure TFormKigouSetting.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

end.
