unit Launcher;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, CommCtrl;

const
  FORM_WIDTH_SET    = 760;
  FORM_HEIGHT_SET   = 470;

type
  TFormLauncher = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel2: TPanel;
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    ButtonOpenFile: TButton;
    Edit2: TEdit;
    ComboBox2: TComboBox;
    ListView1: TListView;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    CheckBox1: TCheckBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOpenFileClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem; Change: TItemChange);
  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;

    BoolJapanese: Boolean;
    StrLanguageFileName: String;
  public
    { Public 錾 }
  end;

var
  FormLauncher: TFormLauncher;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormLauncher.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormLauncher.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormLauncher.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormLauncher.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormLauncher.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  bAutoExit: Boolean;
  nItem: TListItem;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormLauncher', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormLauncher', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormLauncher', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormLauncher', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormLauncher', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //
  OpenDialog1.Filter := 'Exe(*.exe;)|*.exe|All(*.*)|*.*';

  //
  if BoolJapanese = TRUE then
  begin
    //
    ComboBox2.Items.Add(' ');
    ComboBox2.Items.Add(LAUNCHER_FILENAME + ':' + 't@C');
    ComboBox2.Items.Add(LAUNCHER_LINE     + ':' + 'ݍs');
    ComboBox2.Items.Add(LAUNCHER_MERY);
    ComboBox2.Items.Add(LAUNCHER_HIDEMARU);

    //
    ListView1.Items.Clear;
    ListView1.Columns.Add.Caption  := 'No';
    ListView1.Columns[0].Width :=  35;
    ListView1.Columns.Add.Caption  := 't@C';
    ListView1.Columns[1].Width := 480;
    ListView1.Columns.Add.Caption  := 'I';
    ListView1.Columns[2].Width := 100;
    ListView1.Columns.Add.Caption  := '';
    ListView1.Columns[3].Width := 300;
    ListView1.Columns.Add.Caption  := '';
    ListView1.Columns[4].Width :=  10;
    ListView1.ViewStyle := vsReport;
    ListView1.RowSelect := TRUE;
    ListView1.MultiSelect := FALSE;
    ListView1.ReadOnly := TRUE;
  end
  else
  begin
    //
    ComboBox2.Items.Add(' ');
    ComboBox2.Items.Add(LAUNCHER_FILENAME_ENG + ':' + 'FileName');
    ComboBox2.Items.Add(LAUNCHER_LINE_ENG     + ':' + 'Current Row Number');
    ComboBox2.Items.Add(LAUNCHER_MERY_ENG);
    ComboBox2.Items.Add(LAUNCHER_HIDEMARU_ENG);

    //
    ListView1.Items.Clear;
    ListView1.Columns.Add.Caption  := 'No';
    ListView1.Columns[0].Width :=  35;
    ListView1.Columns.Add.Caption  := 'FileName';
    ListView1.Columns[1].Width := 480;
    ListView1.Columns.Add.Caption  := 'AutoExit';
    ListView1.Columns[2].Width := 100;
    ListView1.Columns.Add.Caption  := 'Parameter';
    ListView1.Columns[3].Width := 300;
    ListView1.Columns.Add.Caption  := '';
    ListView1.Columns[4].Width :=  10;
    ListView1.ViewStyle := vsReport;
    ListView1.RowSelect := TRUE;
    ListView1.MultiSelect := FALSE;
    ListView1.ReadOnly := TRUE;
  end;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ݒ
  sStr1     := LAUNCHER_1;
  sStr2     := IniFile.ReadString('Launcher1', 'FolderFile',   '');
  sStr3     := IniFile.ReadString('Launcher1', 'Options',      '');
  bAutoExit := IniFile.ReadBool  ('Launcher1', 'AutoExit',  FALSE);
  nItem := ListView1.Items.Add;
  nItem.Caption := sStr1;
  ListView1.Items.Item[0].SubItems.Add(sStr2);
  if bAutoExit = TRUE then
  begin
    ListView1.Items.Item[0].SubItems.Add('L');
  end
  else
  begin
    ListView1.Items.Item[0].SubItems.Add('');
  end;
  ListView1.Items.Item[0].SubItems.Add(sStr3);
  //ݒ
  sStr1     := LAUNCHER_2;
  sStr2     := IniFile.ReadString('Launcher2', 'FolderFile',   '');
  sStr3     := IniFile.ReadString('Launcher2', 'Options',      '');
  bAutoExit := IniFile.ReadBool  ('Launcher2', 'AutoExit',  FALSE);
  nItem := ListView1.Items.Add;
  nItem.Caption := sStr1;
  ListView1.Items.Item[1].SubItems.Add(sStr2);
  if bAutoExit = TRUE then
  begin
    ListView1.Items.Item[1].SubItems.Add('L');
  end
  else
  begin
    ListView1.Items.Item[1].SubItems.Add('');
  end;
  ListView1.Items.Item[1].SubItems.Add(sStr3);
  //ݒ
  sStr1     := LAUNCHER_3;
  sStr2     := IniFile.ReadString('Launcher3', 'FolderFile',   '');
  sStr3     := IniFile.ReadString('Launcher3', 'Options',      '');
  bAutoExit := IniFile.ReadBool  ('Launcher3', 'AutoExit',  FALSE);
  nItem := ListView1.Items.Add;
  nItem.Caption := sStr1;
  ListView1.Items.Item[2].SubItems.Add(sStr2);
  if bAutoExit = TRUE then
  begin
    ListView1.Items.Item[2].SubItems.Add('L');
  end
  else
  begin
    ListView1.Items.Item[2].SubItems.Add('');
  end;
  ListView1.Items.Item[2].SubItems.Add(sStr3);
  //ݒ
  sStr1     := LAUNCHER_4;
  sStr2     := IniFile.ReadString('Launcher4', 'FolderFile',   '');
  sStr3     := IniFile.ReadString('Launcher4', 'Options',      '');
  bAutoExit := IniFile.ReadBool  ('Launcher4', 'AutoExit',  FALSE);
  nItem := ListView1.Items.Add;
  nItem.Caption := sStr1;
  ListView1.Items.Item[3].SubItems.Add(sStr2);
  if bAutoExit = TRUE then
  begin
    ListView1.Items.Item[3].SubItems.Add('L');
  end
  else
  begin
    ListView1.Items.Item[3].SubItems.Add('');
  end;
  ListView1.Items.Item[3].SubItems.Add(sStr3);
  //ݒ
  sStr1     := LAUNCHER_5;
  sStr2     := IniFile.ReadString('Launcher5', 'FolderFile',   '');
  sStr3     := IniFile.ReadString('Launcher5', 'Options',      '');
  bAutoExit := IniFile.ReadBool  ('Launcher5', 'AutoExit',  FALSE);
  nItem := ListView1.Items.Add;
  nItem.Caption := sStr1;
  ListView1.Items.Item[4].SubItems.Add(sStr2);
  if bAutoExit = TRUE then
  begin
    ListView1.Items.Item[4].SubItems.Add('L');
  end
  else
  begin
    ListView1.Items.Item[4].SubItems.Add('');
  end;
  ListView1.Items.Item[4].SubItems.Add(sStr3);
  //j
  IniFile.Free;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
    ListView1Click(Sender);
  end
  else
  begin
    ListView1.ItemIndex := -1;
  end;
end;

procedure TFormLauncher.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormLauncher', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormLauncher', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormLauncher', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormLauncher', 'Left',   FormLauncher.Left);
    IniFile.WriteInteger('FormLauncher', 'Top',    FormLauncher.Top);
    IniFile.WriteInteger('FormLauncher', 'Width',  FormLauncher.Width);
    IniFile.WriteInteger('FormLauncher', 'Height', FormLauncher.Height);
  end;
  //j
  IniFile.Free;
end;

procedure TFormLauncher.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end;
end;

procedure TFormLauncher.FormResize(Sender: TObject);
begin
  Edit1.Width     := FormLauncher.ClientWidth -  40;
  Edit2.Width     := FormLauncher.ClientWidth -  40;
  ListView1.Width := FormLauncher.ClientWidth -  40;
  ComboBox2.Width := FormLauncher.ClientWidth - 165;
end;

procedure TFormLauncher.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormLauncher.KeyPreview := TRUE;

 //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormLauncher.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormLauncher.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormLauncher.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormLauncher.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Launcher.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormLauncher, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormLauncher, StrLanguageFileName, Sender);
  end;
end;

procedure TFormLauncher.ListView1Change(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  ListView1Click(Sender);
end;

procedure TFormLauncher.ListView1Click(Sender: TObject);
begin
  if ListView1.ItemIndex <> -1 then
  begin
    //ݒ
    Edit1.Text := ListView1.Items[ListView1.ItemIndex].SubItems[0];
    if ListView1.Items[ListView1.ItemIndex].SubItems[1] = 'L' then
    begin
      CheckBox1.Checked := TRUE;
    end
    else
    begin
      CheckBox1.Checked := FALSE;
    end;
    Edit2.Text := ListView1.Items[ListView1.ItemIndex].SubItems[2];
  end;
end;

procedure TFormLauncher.ListView1AdvancedCustomDrawItem(
  Sender: TCustomListView; Item: TListItem; State: TCustomDrawState;
  Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  AIndex: Integer;
  ARect: TRect;
  dwFormat: DWORD;
  iRow1: Integer;
  StrItem: String;
begin
  //tH[JX
  if ListView1.Focused = FALSE then
  begin
    //I
    if Item.Selected then
    begin
      //ݒ
      AIndex := Item.Index;
      //sRecẗ擾Dȉł
      //ListView_GetItemRect(ListView1.Handle, AIndex, ARect, LVIR_BOUNDS);
      ARect := Item.DisplayRect(drBounds);
//      OffsetRect(ARect, 3, 0);
      OffsetRect(ARect, 0, 0);
      //̗̈hׂ
      ListView1.Canvas.Brush.Color := clAqua;
      ListView1.Canvas.FillRect(ARect);
      ListView1.Canvas.Font.Color := clWindowText;

      //ݒ
      SetBkMode(ListView1.Canvas.Handle, TRANSPARENT);
      dwFormat := DT_SINGLELINE or DT_VCENTER;
      //Ō܂ŕ`
      for iRow1 := 0 to ListView1.Columns.Count-2 do
      begin
        //`ʒuݒ
        case ListView1.Column[iRow1].Alignment of
          taRightJustify: dwFormat := dwFormat or DT_RIGHT;
          taCenter      : dwFormat := dwFormat or DT_CENTER;
        else
          dwFormat := dwFormat or DT_LEFT;
        end;
        //Caption̂̏ꍇ
        if iRow1 = 0 then
        begin
          //͈͂擾
          ARect   := Item.DisplayRect(drLabel);
          //
          ARect   := Rect(ARect.Left + 3, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.Caption;
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end
        //CaptionȊO
        else
        begin
          //CommCtrlKvBdvłB
          //͈͂擾
          ListView_GetSubItemRect(ListView1.Handle, AIndex, iRow1, LVIR_LABEL, @ARect);
          //
          ARect   := Rect(ARect.Left + 6, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.SubItems[iRow1-1];
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end;
      end;
      //{̕`͎sȂ悤ɂȂƁAꕔ̍sŃtHgȂĂ܂
      DefaultDraw := False;
    end;
  end;

end;

procedure TFormLauncher.Edit1Change(Sender: TObject);
begin
  //ݒ
  ListView1.Items[ListView1.ItemIndex].SubItems[0] := Edit1.Text;
end;

procedure TFormLauncher.Edit2Change(Sender: TObject);
begin
  //ݒ
  ListView1.Items[ListView1.ItemIndex].SubItems[2] := Edit2.Text;
end;

procedure TFormLauncher.CheckBox1Click(Sender: TObject);
begin
  //ݒ
  if CheckBox1.Checked = TRUE then
  begin
    ListView1.Items[ListView1.ItemIndex].SubItems[1] := 'L';
  end
  else
  begin
    ListView1.Items[ListView1.ItemIndex].SubItems[1] := '';
  end;
end;

procedure TFormLauncher.ComboBox2Change(Sender: TObject);
var
  sStr2: String;
  iPos1: Integer;
begin
  //
  if ComboBox2.Text = ' ' then
  begin
    sStr2 := '';
  end
  else
  begin
    //$(FileNameEx) : t@C
    iPos1 := Pos(':', ComboBox2.Text);
    sStr2 := Copy(ComboBox2.Text, 1, ipos1-1);
  end;

  //ݒ
  Edit2.Text := sStr2;
end;

procedure TFormLauncher.ButtonOKClick(Sender: TObject);
var
  IniFile: TIniFile;
  sStr1: String;
  sStr2: String;
  bAutoExit: Boolean;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  sStr1 := ListView1.Items[0].SubItems[0];
  if ListView1.Items[0].SubItems[1] = 'L' then
  begin
    bAutoExit := TRUE;
  end
  else
  begin
    bAutoExit := FALSE;
  end;
  sStr2 := ListView1.Items[0].SubItems[2];
  IniFile.WriteString('Launcher1', 'FolderFile',   sStr1);
  IniFile.WriteString('Launcher1', 'Options',      sStr2);
  IniFile.WriteBool  ('Launcher1', 'AutoExit',     bAutoExit);
  //ۑ
  sStr1 := ListView1.Items[1].SubItems[0];
  if ListView1.Items[1].SubItems[1] = 'L' then
  begin
    bAutoExit := TRUE;
  end
  else
  begin
    bAutoExit := FALSE;
  end;
  sStr2 := ListView1.Items[1].SubItems[2];
  IniFile.WriteString('Launcher2', 'FolderFile',   sStr1);
  IniFile.WriteString('Launcher2', 'Options',      sStr2);
  IniFile.WriteBool  ('Launcher2', 'AutoExit',     bAutoExit);
  //ۑ
  sStr1 := ListView1.Items[2].SubItems[0];
  if ListView1.Items[2].SubItems[1] = 'L' then
  begin
    bAutoExit := TRUE;
  end
  else
  begin
    bAutoExit := FALSE;
  end;
  sStr2 := ListView1.Items[2].SubItems[2];
  IniFile.WriteString('Launcher3', 'FolderFile',   sStr1);
  IniFile.WriteString('Launcher3', 'Options',      sStr2);
  IniFile.WriteBool  ('Launcher3', 'AutoExit',     bAutoExit);
  //ۑ
  sStr1 := ListView1.Items[3].SubItems[0];
  if ListView1.Items[3].SubItems[1] = 'L' then
  begin
    bAutoExit := TRUE;
  end
  else
  begin
    bAutoExit := FALSE;
  end;
  sStr2 := ListView1.Items[3].SubItems[2];
  IniFile.WriteString('Launcher4', 'FolderFile',   sStr1);
  IniFile.WriteString('Launcher4', 'Options',      sStr2);
  IniFile.WriteBool  ('Launcher4', 'AutoExit',     bAutoExit);
  //ۑ
  sStr1 := ListView1.Items[4].SubItems[0];
  if ListView1.Items[4].SubItems[1] = 'L' then
  begin
    bAutoExit := TRUE;
  end
  else
  begin
    bAutoExit := FALSE;
  end;
  sStr2 := ListView1.Items[4].SubItems[2];
  IniFile.WriteString('Launcher5', 'FolderFile',   sStr1);
  IniFile.WriteString('Launcher5', 'Options',      sStr2);
  IniFile.WriteBool  ('Launcher5', 'AutoExit',     bAutoExit);
  //j
  IniFile.Free;

  //I
  Close;
end;

procedure TFormLauncher.ButtonCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormLauncher.ButtonOpenFileClick(Sender: TObject);
begin
  //
  if FileExists(Edit1.Text) = TRUE then
  begin
    OpenDialog1.InitialDir := ExtractFilePath(Edit1.Text);
    OpenDialog1.FileName   := ExtractFileName(Edit1.Text);
  end
  else
  begin
    OpenDialog1.InitialDir := '';
    OpenDialog1.FileName   := '';
  end;
  OpenDialog1.Filter := 'Exe(*.exe)|*.exe|All(*.*)|*.*';
  if OpenDialog1.Execute = TRUE then
  begin
    Edit1.Text := OpenDialog1.FileName;
  end;
end;

procedure TFormLauncher.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormLauncher.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormLauncher.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

end.

