unit LineSetting;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, DecEdit, Vcl.ExtCtrls,
  IniFiles;


type
  TFormLineSetting = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label5: TLabel;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    DecEdit1: TDecEdit;
    RadioGroup1: TRadioGroup;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
  private
    { Private 錾 }
    BoolJapanese: Boolean;
    StrLanguageFileName: String;
  public
    { Public 錾 }
  end;

var
  FormLineSetting: TFormLineSetting;

implementation

{$R *.dfm}

uses Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormLineSetting.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormLineSetting.FormClose(Sender: TObject; var Action: TCloseAction);
begin
;
end;

procedure TFormLineSetting.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormLineSetting.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  DecEdit1.Text := IntToStr(IniFile.ReadInteger('Editor', 'LineWidth',  80));
  RadioGroup1.ItemIndex  := IniFile.ReadInteger('Editor', 'LineZero',    1);
  //j
  IniFile.Free;
end;

procedure TFormLineSetting.FormDestroy(Sender: TObject);
begin
;
end;

procedure TFormLineSetting.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end;
end;

procedure TFormLineSetting.FormResize(Sender: TObject);
begin
;
end;

procedure TFormLineSetting.FormShow(Sender: TObject);
var
  IniFile: TiniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormLineSetting.KeyPreview := TRUE;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'LineSetting.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormLineSetting, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormlineSetting, StrLanguageFileName, Sender);
  end;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //Ǎ
  RadioGroup1.ItemIndex  := IniFile.ReadInteger('Editor', 'LineZero',    1);
  //j
  IniFile.Free;
end;

procedure TFormLineSetting.ButtonOkClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  IniFile.WriteInteger('Editor', 'LineWidth',  StrToInt(DecEdit1.Text));
  IniFile.WriteInteger('Editor', 'LineZero',   RadioGroup1.ItemIndex);
  //j
  IniFile.Free;

  //I
  ModalResult := mrOK;
end;

procedure TFormLineSetting.ButtonCancelClick(Sender: TObject);
begin
  //I
  ModalResult := mrCancel;
end;

end.
