unit PageSetting;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

type
  TFormPageSetting = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Timer1: TTimer;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    BoolJapanese: Boolean;
    StrLanguageFileName: String;
  public
    { Public 錾 }
  end;

var
  FormPageSetting: TFormPageSetting;

implementation

{$R *.dfm}

uses Main;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormPageSetting.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormPageSetting.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormPageSetting.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormPageSetting.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //
  Timer1.Enabled := FALSE;

  //
  for iRow1 := 0 to FormMain.StrListScrollVale.Count-1 do
  begin
    ComboBox1.Items.Add(FormMain.StrListScrollVale.Strings[iRow1]);
    ComboBox2.Items.Add(FormMain.StrListScrollVale.Strings[iRow1]);
    ComboBox3.Items.Add(FormMain.StrListScrollVale.Strings[iRow1]);
  end;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ǂݍ
  ComboBox1.ItemIndex := IniFile.ReadInteger('Editor', 'ScrollPlusPlusPlusIndex',  17-1);
  ComboBox2.ItemIndex := IniFile.ReadInteger('Editor', 'ScrollPlusPlusIndex',      17-1);
  ComboBox3.ItemIndex := IniFile.ReadInteger('Editor', 'ScrollPlusIndex',           3-1);
  //j
  IniFile.Free;
end;

procedure TFormPageSetting.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TFormPageSetting.FormResize(Sender: TObject);
begin
  //
end;

procedure TFormPageSetting.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormPageSetting.KeyPreview := TRUE;
  //tH[JX
  ButtonCancel.SetFocus;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'PageSetting.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormPageSetting, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormPageSetting, StrLanguageFileName, Sender);
  end;

  //  ComboBox1.SetFocus;
  Timer1.Enabled := TRUE;
end;

procedure TFormPageSetting.Timer1Timer(Sender: TObject);
var
  Key: Word;
begin
  //Zbg
  Timer1.Enabled := FALSE;

  //L[ݒ
  Key := VK_TAB;
  //L[
  keybd_event(0, 0, 0, 0);
  //L[}
  keybd_event(Key, 0, 0, 0);
  //L[𗣂iK{j}
  keybd_event(Key, 0, KEYEVENTF_KEYUP, 0);
  //L[𗣂iK{j}
  keybd_event(0,   0, KEYEVENTF_KEYUP, 0);
end;

procedure TFormPageSetting.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end;
end;

procedure TFormPageSetting.ButtonOkClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  IniFile.WriteInteger('Editor', 'ScrollPlusPlusPlusIndex', ComboBox1.ItemIndex);
  IniFile.WriteInteger('Editor', 'ScrollPlusPlusIndex',     ComboBox2.ItemIndex);
  IniFile.WriteInteger('Editor', 'ScrollPlusIndex',         ComboBox3.ItemIndex);
  //j
  IniFile.Free;
  //
  ModalResult := mrOk;
end;

procedure TFormPageSetting.ButtonCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

end.
