unit SelectFiler;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Menus, IniFiles;

const
  FORM_WIDTH_SET    = 680;
  FORM_HEIGHT_SET   = 350;

type
  TFormSelectFiler = class(TForm)
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuRun: TMenuItem;
    MenuClose: TMenuItem;
    Panel6: TPanel;
    ButtonRun: TButton;
    ButtonCancel: TButton;
    ButtonGetList: TButton;
    ButtonSave: TButton;
    ButtonInit: TButton;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    ListBox1: TListBox;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure ButtonGetListClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure ButtonRunClick(Sender: TObject);
    procedure ButtonInitClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure MenuCloseClick(Sender: TObject);
    procedure MenuRunClick(Sender: TObject);
    procedure SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
  private
    { Private 錾 }
    StrFormState: String;
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    StrListKeyMap: TStringList;
    StrListTitleName: TStringList;
    StrListWindowName: TStringList;
    StrListWindowHwnd: TStringList;
    BoolJapanese: Boolean;
    StrLanguageFileName: String;
  public
    { Public 錾 }
  end;

var
  FormSelectFiler: TFormSelectFiler;

implementation

uses
  Main;

{$R *.dfm}

//WindowsAPIR[obN֐ EBhE̗
function EnumWindowsProc(Wnd: HWND; lParam: Longint): Bool; stdcall; export;
var
  szCaption: array [0..255] of Char;
  iRow1: Integer;
  iPos1: Integer;
  iPos2: Integer;
  sStr1: String;
  sStr2: String;
  sStr3: String;
begin
  //ݒ
  Result:= TRUE;
  //EBhEnh擾
  GetWindowText(Wnd, szCaption, sizeof(szCaption));

  //
  for iRow1 := 0 to FormSelectFiler.StrListTitleName.Count-1 do
  begin
    sStr1 := FormSelectFiler.StrListTitleName.Strings[iRow1];
    if Length(sStr1) > 3 then
    begin
      sStr2 := Copy(sStr1, 1, 1);
      sStr3 := Copy(sStr1, 3, Length(sStr1));
      if sStr2 = '1' then
      begin
        //g̃Av͏
        iPos1 := Pos(UpperCase(sStr3),     UpperCase(StrPas(szCaption)));
        iPos2 := Pos(UpperCase(FORM_THIS), UpperCase(StrPas(szCaption)));
        if (iPos1 > 0) and (iPos2 = 0) then
        begin
          FormSelectFiler.StrListWindowName.Add(StrPas(szCaption));
          FormSelectFiler.StrListWindowHwnd.Add(IntToStr(Wnd));
        end;
      end;
    end;
  end;
end;

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormSelectFiler.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormSelectFiler.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormSelectFiler.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormSelectFiler.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormSelectFiler.FormCreate(Sender: TObject);
var
  sStr1: String;
  IniFile: TiniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  FormPosLeft   := IniFile.ReadInteger('FormSelectFiler', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormSelectFiler', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormSelectFiler', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormSelectFiler', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormSelectFiler', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;

  //m
  StrListTitleName := TStringList.Create;
  StrListWindowName := TStringList.Create;
  StrListWindowHwnd := TStringList.Create;
  StrListKeyMap := TStringList.Create;
  //Ǎ
  sStr1 := ExtractFilePath(ParamStr(0)) + TITLE_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    StrListTitleName.LoadFromFile(sStr1, TEncoding.Unicode);
  end
  else
  begin
    StrListTitleName.Add('1 - annsFM');
    StrListTitleName.Add('1 - BonsFM');
    StrListTitleName.Add('0');
    StrListTitleName.Add('0');
  end;

  //L
  if Copy(StrListTitleName.Strings[0], 1, 1) = '1' then
  begin
    CheckBox1.Checked := TRUE;
  end
  else
  begin
    CheckBox1.Checked := FALSE;
  end;
  if Copy(StrListTitleName.Strings[1], 1, 1) = '1' then
  begin
    CheckBox2.Checked := TRUE;
  end
  else
  begin
    CheckBox2.Checked := FALSE;
  end;
  if Copy(StrListTitleName.Strings[2], 1, 1) = '1' then
  begin
    CheckBox3.Checked := TRUE;
  end
  else
  begin
    CheckBox3.Checked := FALSE;
  end;
  if Copy(StrListTitleName.Strings[3], 1, 1) = '1' then
  begin
    CheckBox4.Checked := TRUE;
  end
  else
  begin
    CheckBox4.Checked := FALSE;
  end;

  //^Cg
  if Length(StrListTitleName.Strings[0]) > 3 then
  begin
    Edit1.Text := Copy(StrListTitleName.Strings[0], 3, Length(StrListTitleName.Strings[0]));
  end
  else
  begin
    Edit1.Text := '';
  end;
  if Length(StrListTitleName.Strings[1]) > 3 then
  begin
    Edit2.Text := Copy(StrListTitleName.Strings[1], 3, Length(StrListTitleName.Strings[1]));
  end
  else
  begin
    Edit2.Text := '';
  end;
  if Length(StrListTitleName.Strings[2]) > 3 then
  begin
    Edit3.Text := Copy(StrListTitleName.Strings[2], 3, Length(StrListTitleName.Strings[2]));
  end
  else
  begin
    Edit3.Text := '';
  end;
  if Length(StrListTitleName.Strings[3]) > 3 then
  begin
    Edit4.Text := Copy(StrListTitleName.Strings[3], 3, Length(StrListTitleName.Strings[3]));
  end
  else
  begin
    Edit4.Text := '';
  end;
end;

procedure TFormSelectFiler.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormSelectFiler', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormSelectFiler', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormSelectFiler', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormSelectFiler', 'Left',   FormSelectFiler.Left);
    IniFile.WriteInteger('FormSelectFiler', 'Top',    FormSelectFiler.Top);
    IniFile.WriteInteger('FormSelectFiler', 'Width',  FormSelectFiler.Width);
    IniFile.WriteInteger('FormSelectFiler', 'Height', FormSelectFiler.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListTitleName.Free;
  StrListWindowName.Free;
  StrListWindowHwnd.Free;
  StrListKeyMap.Free;
end;

procedure TFormSelectFiler.FormResize(Sender: TObject);
begin
  Edit1.Width := FormSelectFiler.ClientWidth - 105;
  Edit2.Width := FormSelectFiler.ClientWidth - 105;
  Edit3.Width := FormSelectFiler.ClientWidth - 105;
  Edit4.Width := FormSelectFiler.ClientWidth - 105;
end;

procedure TFormSelectFiler.FormShow(Sender: TObject);
var
  sStr1: String;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormSelectFiler.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormSelectFiler.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormSelectFiler.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormSelectFiler.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormSelectFiler.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, FORM_WIDTH_SET*5, 0);

  //NA
  StrListWindowName.Clear;
  StrListWindowHwnd.Clear;

  //擾
  EnumWindows(@EnumWindowsProc, 0);

  //ݒ
  ListBox1.Items.Clear;
  if StrListWindowName.Count > 0 then
  begin
    ListBox1.Items.Assign(StrListWindowName);
    ListBox1.ItemIndex := 0;
  end;

  //t@CǍ
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
  if FileExists(sStr1) = TRUE then
  begin
    //Ǎ
    StrListKeyMap.LoadFromFile(sStr1, TEncoding.Unicode);
  end;

  //V[gJbgݒ
  if StrListKeyMap.Count > 0 then
  begin
    SetShortCutNew('1031', MenuClose, Sender);
    SetShortCutNew('1711', MenuRun, Sender);
  end;

  //ݒ
  BoolJapanese := FormMain.BoolJapanese;
  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'SelectFiler.txt';
  if BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormSelectFiler, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormSelectFiler, StrLanguageFileName, Sender);
  end;
end;

procedure TFormSelectFiler.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end;
end;

procedure TFormSelectFiler.ButtonCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormSelectFiler.ButtonSaveClick(Sender: TObject);
var
  sStr1: String;
begin
  //NA
  StrListTitleName.Clear;

  //ݒ
  if CheckBox1.Checked = TRUE then
  begin
    StrListTitleName.Add('1 ' + Edit1.Text)
  end
  else
  begin
    StrListTitleName.Add('0 ' + Edit1.Text)
  end;
  if CheckBox2.Checked = TRUE then
  begin
    StrListTitleName.Add('1 ' + Edit2.Text)
  end
  else
  begin
    StrListTitleName.Add('0 ' +Edit2.Text)
  end;
  if CheckBox3.Checked = TRUE then
  begin
    StrListTitleName.Add('1 ' + Edit3.Text)
  end
  else
  begin
    StrListTitleName.Add('0 ' + Edit3.Text)
  end;
  if CheckBox4.Checked = TRUE then
  begin
    StrListTitleName.Add('1 ' + Edit4.Text)
  end
  else
  begin
    StrListTitleName.Add('0 ' + Edit4.Text)
  end;

  //ۑ
  sStr1 := ExtractFilePath(ParamStr(0)) + TITLE_LIST;
  StrListTitleName.SaveToFile(sStr1, TEncoding.Unicode);

  //I
  Close;
end;

procedure TFormSelectFiler.ButtonRunClick(Sender: TObject);
var
  AppWnd: HWND;
begin
  //₪L
  if ListBox1.Items.Count > 0 then
  begin
    //nhݒ
    AppWnd := StrToInt(StrListWindowHwnd.Strings[ListBox1.ItemIndex]);
    //OʂɈړ
    SetForegroundWindow(AppWnd);
    //ACRԂȂ猳ɖ߂
    if IsIconic(AppWnd) then
    begin
      SendMessage(AppWnd, WM_SYSCOMMAND, SC_RESTORE, -1);
    end;
  end;
  //I
  Close;
end;

procedure TFormSelectFiler.ButtonInitClick(Sender: TObject);
begin
  CheckBox1.Checked := TRUE;
  CheckBox2.Checked := TRUE;
  CheckBox3.Checked := FALSE;
  CheckBox4.Checked := FALSE;

  Edit1.Text := '- annsFM';
  Edit2.Text := '- BonsFM';
  Edit3.Text := '';
  Edit4.Text := '';
end;

procedure TFormSelectFiler.ButtonGetListClick(Sender: TObject);
begin
  //NA
  StrListTitleName.Clear;

  //ݒ
  if CheckBox1.Checked = TRUE then
  begin
    StrListTitleName.Add('1 ' + Edit1.Text)
  end
  else
  begin
    StrListTitleName.Add('0 ' + Edit1.Text)
  end;
  if CheckBox2.Checked = TRUE then
  begin
    StrListTitleName.Add('1 ' + Edit2.Text)
  end
  else
  begin
    StrListTitleName.Add('0 ' +Edit2.Text)
  end;
  if CheckBox3.Checked = TRUE then
  begin
    StrListTitleName.Add('1 ' + Edit3.Text)
  end
  else
  begin
    StrListTitleName.Add('0 ' + Edit3.Text)
  end;
  if CheckBox4.Checked = TRUE then
  begin
    StrListTitleName.Add('1 ' + Edit4.Text)
  end
  else
  begin
    StrListTitleName.Add('0 ' + Edit4.Text)
  end;

  //NA
  StrListWindowName.Clear;
  StrListWindowHwnd.Clear;

  //擾
  EnumWindows(@EnumWindowsProc, 0);

  //ݒ
  ListBox1.Items.Clear;
  if StrListWindowName.Count > 0 then
  begin
    ListBox1.Items.Assign(StrListWindowName);
    ListBox1.ItemIndex := 0;
  end;
end;

procedure TFormSelectFiler.ListBox1DblClick(Sender: TObject);
begin
  //s
  ButtonRunClick(Sender);
end;

procedure TFormSelectFiler.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormSelectFiler.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormSelectFiler.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
 end;

procedure TFormSelectFiler.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormSelectFiler.ListBox1KeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
  //Enter
  if      (Shift = []) and (key = VK_RETURN) then
  begin
    //s
    ButtonRunClick(Sender);
  end;
end;

procedure TFormSelectFiler.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //ListBox ̃X^C lbOwnerDrawFixed w肷
  with (Control as TListBox) do
  begin
    //tH[JX
    if (odFocused in State) = TRUE then
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clHighlight;
        Canvas.Font.Color  := clWhite;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end;
    end
    //tH[JXȂ
    else
    begin
      //I
      if odSelected in State then
      begin
        Canvas.Brush.Color := clAqua;
        Canvas.Font.Color  := clWindowText;
      end
      //I
      else
      begin
        Canvas.Brush.Color := clWindow;
        Canvas.Font.Color  := clWindowText;
      end;
    end;
    //`
    Canvas.FillRect(Rect);
    Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
  end;
end;

procedure TFormSelectFiler.MenuCloseClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormSelectFiler.SetShortCutNew(Number: String; MenuItemName: TMenuItem; Sender: TObject);
var
  sStr3: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iFind1: Integer;
  iPos3: Integer;
  iPos4: Integer;
  iPos5: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  Shift: TShiftState;
  Key: Word;
begin
  //ԍ̃V[gJbgݒ
  iFind1 := -1;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      iFind1 := iRow1;
      Break;
    end;
  end;
  if iFind1 = -1 then
  begin
    Exit;
  end;
  //ݒ
  sStr3 := sStr16;

  //
  iPos3 := Pos('Shift',  sStr3);
  iPos4 := Pos('Ctrl',   sStr3);
  iPos5 := Pos('Alt',    sStr3);
  sStr5 := StringReplace(sStr3, 'Shift', '', [rfReplaceAll]);
  sStr6 := StringReplace(sStr5, 'Ctrl',  '', [rfReplaceAll]);
  sStr7 := StringReplace(sStr6, 'Alt',   '', [rfReplaceAll]);
  sStr8 := StringReplace(sStr7, '+',     '', [rfReplaceAll]);
  sStr9 := Trim         (sStr8);
  //L[
  if      sStr9 = '0' then
  begin
    Key := VK_0;
  end
  else if sStr9 = '1' then
  begin
    Key := VK_1;
  end
  else if sStr9 = '2' then
  begin
    Key := VK_2;
  end
  else if sStr9 = '3' then
  begin
    Key := VK_3;
  end
  else if sStr9 = '4' then
  begin
    Key := VK_4;
  end
  else if sStr9 = '5' then
  begin
    Key := VK_5;
  end
  else if sStr9 = '6' then
  begin
    Key := VK_6;
  end
  else if sStr9 = '7' then
  begin
    Key := VK_7;
  end
  else if sStr9 = '8' then
  begin
    Key := VK_8;
  end
  else if sStr9 = '9' then
  begin
    Key := VK_9;
  end

  else if sStr9 = 'A' then
  begin
    Key := VK_A;
  end
  else if sStr9 = 'B' then
  begin
    Key := VK_B;
  end
  else if sStr9 = 'C' then
  begin
    Key := VK_C;
  end
  else if sStr9 = 'D' then
  begin
    Key := VK_D;
  end
  else if sStr9 = 'E' then
  begin
    Key := VK_E;
  end
  else if sStr9 = 'F' then
  begin
    Key := VK_F;
  end
  else if sStr9 = 'G' then
  begin
    Key := VK_G;
  end
  else if sStr9 = 'H' then
  begin
    Key := VK_H;
  end
  else if sStr9 = 'I' then
  begin
    Key := VK_I;
  end
  else if sStr9 = 'J' then
  begin
    Key := VK_J;
  end
  else if sStr9 = 'K' then
  begin
    Key := VK_K;
  end
  else if sStr9 = 'L' then
  begin
    Key := VK_L;
  end
  else if sStr9 = 'M' then
  begin
    Key := VK_M;
  end
  else if sStr9 = 'N' then
  begin
    Key := VK_N;
  end
  else if sStr9 = 'O' then
  begin
    Key := VK_O;
  end
  else if sStr9 = 'P' then
  begin
    Key := VK_P;
  end
  else if sStr9 = 'Q' then
  begin
    Key := VK_Q;
  end
  else if sStr9 = 'R' then
  begin
    Key := VK_R;
  end
  else if sStr9 = 'S' then
  begin
    Key := VK_S;
  end
  else if sStr9 = 'T' then
  begin
    Key := VK_T;
  end
  else if sStr9 = 'U' then
  begin
    Key := VK_U;
  end
  else if sStr9 = 'V' then
  begin
    Key := VK_V;
  end
  else if sStr9 = 'W' then
  begin
    Key := VK_W;
  end
  else if sStr9 = 'X' then
  begin
    Key := VK_X;
  end
  else if sStr9 = 'Y' then
  begin
    Key := VK_Y;
  end
  else if sStr9 = 'Z' then
  begin
    Key := VK_Z;
  end

  else if sStr9 = ',' then
  begin
    Key := VK_COMMA;
  end
  else if sStr9 = '.' then
  begin
    Key := VK_PIRIOD ;
  end
  else if sStr9 = '/' then
  begin
    Key := VK_SLASH;
  end
  else if sStr9 = ';' then
  begin
    Key := VK_SEMICOLLON;
  end
  else if sStr9 = ':' then
  begin
    Key := VK_COLLON;
  end
  else if sStr9 = ']' then
  begin
    Key := VK_RIGHT_KAGI;
  end
  else if sStr9 = '@' then
  begin
    Key := VK_AT_MARK;
  end
  else if sStr9 = '[' then
  begin
    Key := VK_LEFT_KAGI;
  end
  else if sStr9 = '-' then
  begin
    Key := VK_MINUS;
  end
  else if sStr9 = '^' then
  begin
    Key := VK_HATTO;
  end
  else if sStr9 = '\' then
  begin
    Key := VK_YEN;
  end

  else if sStr9 = 'F1' then
  begin
    Key := VK_F1;
  end
  else if sStr9 = 'F2' then
  begin
    Key := VK_F2;
  end
  else if sStr9 = 'F3' then
  begin
    Key := VK_F3;
  end
  else if sStr9 = 'F4' then
  begin
    Key := VK_F4;
  end
  else if sStr9 = 'F5' then
  begin
    Key := VK_F5;
  end
  else if sStr9 = 'F6' then
  begin
    Key := VK_F6;
  end
  else if sStr9 = 'F7' then
  begin
    Key := VK_F7;
  end
  else if sStr9 = 'F8' then
  begin
    Key := VK_F8;
  end
  else if sStr9 = 'F9' then
  begin
    Key := VK_F9;
  end
  else if sStr9 = 'F10' then
  begin
    Key := VK_F10;
  end
  else if sStr9 = 'F11' then
  begin
    Key := VK_F11;
  end
  else if sStr9 = 'F12' then
  begin
    Key := VK_F12;
  end

  else if sStr9 = 'Space' then
  begin
    Key := VK_SPACE;
  end
  else if sStr9 = 'Esc' then
  begin
    Key := VK_ESCAPE;
  end
  else if sStr9 = 'Enter' then
  begin
    Key := VK_RETURN;
  end
  else if sStr9 = 'Tab' then
  begin
    Key := VK_TAB;
  end
  else if sStr9 = 'Up' then
  begin
    Key := VK_UP;
  end
  else if sStr9 = 'Down' then
  begin
    Key := VK_DOWN;
  end
  else if sStr9 = 'Left' then
  begin
    Key := VK_LEFT;
  end
  else if sStr9 = 'Right' then
  begin
    Key := VK_RIGHT;
  end
  else if sStr9 = 'Home' then
  begin
    Key := VK_HOME;
  end
  else if sStr9 = 'End' then
  begin
    Key := VK_END;
  end
  else if sStr9 = 'PgUp' then
  begin
    Key := VK_PRIOR;
  end
  else if sStr9 = 'PgDn' then
  begin
    Key := VK_NEXT;
  end
  else if sStr9 = 'Ins' then
  begin
    Key := VK_INSERT;
  end
  else if sStr9 = 'Del' then
  begin
    Key := VK_DELETE;
  end
  else if sStr9 = 'BkSp' then
  begin
    Key := VK_BACK;
  end

  else
  begin
    Key := 0;
  end;

  //L[
  if      (iPos3 = 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssCtrl];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 = 0) then
  begin
    Shift := [ssShift, ssCtrl];
  end
  else if (iPos3 = 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 = 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssAlt];
  end
  else if (iPos3 = 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssCtrl, ssAlt];
  end
  else if (iPos3 > 0) and (iPos4 > 0) and (iPos5 > 0) then
  begin
    Shift := [ssShift, ssCtrl, ssAlt];
  end
  else
  begin
  end;

  //ݒ
  MenuItemName.ShortCut := ShortCut(Key, Shift);

end;

procedure TFormSelectFiler.MenuRunClick(Sender: TObject);
begin
  ButtonRunClick(Sender);
end;

end.

